<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArrayOfQualificationResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfArrayOfQualificationResponse extends AbstractStructArrayBase
{
    /**
     * The ArrayOfQualificationResponse
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfQualificationResponse[]
     */
    public $ArrayOfQualificationResponse;
    /**
     * Constructor method for ArrayOfArrayOfQualificationResponse
     * @uses ArrayOfArrayOfQualificationResponse::setArrayOfQualificationResponse()
     * @param \ArrayType\ArrayOfQualificationResponse[] $arrayOfQualificationResponse
     */
    public function __construct(array $arrayOfQualificationResponse = array())
    {
        $this
            ->setArrayOfQualificationResponse($arrayOfQualificationResponse);
    }
    /**
     * Get ArrayOfQualificationResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfQualificationResponse[]|null
     */
    public function getArrayOfQualificationResponse()
    {
        return isset($this->ArrayOfQualificationResponse) ? $this->ArrayOfQualificationResponse : null;
    }
    /**
     * Set ArrayOfQualificationResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \ArrayType\ArrayOfQualificationResponse[] $arrayOfQualificationResponse
     * @return \ArrayType\ArrayOfArrayOfQualificationResponse
     */
    public function setArrayOfQualificationResponse(array $arrayOfQualificationResponse = array())
    {
        foreach ($arrayOfQualificationResponse as $arrayOfArrayOfQualificationResponseArrayOfQualificationResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfArrayOfQualificationResponseArrayOfQualificationResponseItem instanceof \ArrayType\ArrayOfQualificationResponse) {
                throw new \InvalidArgumentException(sprintf('The ArrayOfQualificationResponse property can only contain items of \ArrayType\ArrayOfQualificationResponse, "%s" given', is_object($arrayOfArrayOfQualificationResponseArrayOfQualificationResponseItem) ? get_class($arrayOfArrayOfQualificationResponseArrayOfQualificationResponseItem) : gettype($arrayOfArrayOfQualificationResponseArrayOfQualificationResponseItem)), __LINE__);
            }
        }
        if (is_null($arrayOfQualificationResponse) || (is_array($arrayOfQualificationResponse) && empty($arrayOfQualificationResponse))) {
            unset($this->ArrayOfQualificationResponse);
        } else {
            $this->ArrayOfQualificationResponse = $arrayOfQualificationResponse;
        }
        return $this;
    }
    /**
     * Add item to ArrayOfQualificationResponse value
     * @throws \InvalidArgumentException
     * @param \ArrayType\ArrayOfQualificationResponse $item
     * @return \ArrayType\ArrayOfArrayOfQualificationResponse
     */
    public function addToArrayOfQualificationResponse(\ArrayType\ArrayOfQualificationResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \ArrayType\ArrayOfQualificationResponse) {
            throw new \InvalidArgumentException(sprintf('The ArrayOfQualificationResponse property can only contain items of \ArrayType\ArrayOfQualificationResponse, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArrayOfQualificationResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \ArrayType\ArrayOfQualificationResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \ArrayType\ArrayOfQualificationResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \ArrayType\ArrayOfQualificationResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \ArrayType\ArrayOfQualificationResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \ArrayType\ArrayOfQualificationResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArrayOfQualificationResponse
     */
    public function getAttributeName()
    {
        return 'ArrayOfQualificationResponse';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfArrayOfQualificationResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
