<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCommissionBonusResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfCommissionBonusResponse extends AbstractStructArrayBase
{
    /**
     * The CommissionBonusResponse
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CommissionBonusResponse[]
     */
    public $CommissionBonusResponse;
    /**
     * Constructor method for ArrayOfCommissionBonusResponse
     * @uses ArrayOfCommissionBonusResponse::setCommissionBonusResponse()
     * @param \StructType\CommissionBonusResponse[] $commissionBonusResponse
     */
    public function __construct(array $commissionBonusResponse = array())
    {
        $this
            ->setCommissionBonusResponse($commissionBonusResponse);
    }
    /**
     * Get CommissionBonusResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CommissionBonusResponse[]|null
     */
    public function getCommissionBonusResponse()
    {
        return isset($this->CommissionBonusResponse) ? $this->CommissionBonusResponse : null;
    }
    /**
     * Set CommissionBonusResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CommissionBonusResponse[] $commissionBonusResponse
     * @return \ArrayType\ArrayOfCommissionBonusResponse
     */
    public function setCommissionBonusResponse(array $commissionBonusResponse = array())
    {
        foreach ($commissionBonusResponse as $arrayOfCommissionBonusResponseCommissionBonusResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfCommissionBonusResponseCommissionBonusResponseItem instanceof \StructType\CommissionBonusResponse) {
                throw new \InvalidArgumentException(sprintf('The CommissionBonusResponse property can only contain items of \StructType\CommissionBonusResponse, "%s" given', is_object($arrayOfCommissionBonusResponseCommissionBonusResponseItem) ? get_class($arrayOfCommissionBonusResponseCommissionBonusResponseItem) : gettype($arrayOfCommissionBonusResponseCommissionBonusResponseItem)), __LINE__);
            }
        }
        if (is_null($commissionBonusResponse) || (is_array($commissionBonusResponse) && empty($commissionBonusResponse))) {
            unset($this->CommissionBonusResponse);
        } else {
            $this->CommissionBonusResponse = $commissionBonusResponse;
        }
        return $this;
    }
    /**
     * Add item to CommissionBonusResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\CommissionBonusResponse $item
     * @return \ArrayType\ArrayOfCommissionBonusResponse
     */
    public function addToCommissionBonusResponse(\StructType\CommissionBonusResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CommissionBonusResponse) {
            throw new \InvalidArgumentException(sprintf('The CommissionBonusResponse property can only contain items of \StructType\CommissionBonusResponse, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CommissionBonusResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CommissionBonusResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CommissionBonusResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CommissionBonusResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CommissionBonusResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CommissionBonusResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CommissionBonusResponse
     */
    public function getAttributeName()
    {
        return 'CommissionBonusResponse';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCommissionBonusResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
