<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerLeadSocialNetworksResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerLeadSocialNetworksResponse extends AbstractStructArrayBase
{
    /**
     * The CustomerLeadSocialNetworksResponse
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CustomerLeadSocialNetworksResponse[]
     */
    public $CustomerLeadSocialNetworksResponse;
    /**
     * Constructor method for ArrayOfCustomerLeadSocialNetworksResponse
     * @uses ArrayOfCustomerLeadSocialNetworksResponse::setCustomerLeadSocialNetworksResponse()
     * @param \StructType\CustomerLeadSocialNetworksResponse[] $customerLeadSocialNetworksResponse
     */
    public function __construct(array $customerLeadSocialNetworksResponse = array())
    {
        $this
            ->setCustomerLeadSocialNetworksResponse($customerLeadSocialNetworksResponse);
    }
    /**
     * Get CustomerLeadSocialNetworksResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CustomerLeadSocialNetworksResponse[]|null
     */
    public function getCustomerLeadSocialNetworksResponse()
    {
        return isset($this->CustomerLeadSocialNetworksResponse) ? $this->CustomerLeadSocialNetworksResponse : null;
    }
    /**
     * Set CustomerLeadSocialNetworksResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerLeadSocialNetworksResponse[] $customerLeadSocialNetworksResponse
     * @return \ArrayType\ArrayOfCustomerLeadSocialNetworksResponse
     */
    public function setCustomerLeadSocialNetworksResponse(array $customerLeadSocialNetworksResponse = array())
    {
        foreach ($customerLeadSocialNetworksResponse as $arrayOfCustomerLeadSocialNetworksResponseCustomerLeadSocialNetworksResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerLeadSocialNetworksResponseCustomerLeadSocialNetworksResponseItem instanceof \StructType\CustomerLeadSocialNetworksResponse) {
                throw new \InvalidArgumentException(sprintf('The CustomerLeadSocialNetworksResponse property can only contain items of \StructType\CustomerLeadSocialNetworksResponse, "%s" given', is_object($arrayOfCustomerLeadSocialNetworksResponseCustomerLeadSocialNetworksResponseItem) ? get_class($arrayOfCustomerLeadSocialNetworksResponseCustomerLeadSocialNetworksResponseItem) : gettype($arrayOfCustomerLeadSocialNetworksResponseCustomerLeadSocialNetworksResponseItem)), __LINE__);
            }
        }
        if (is_null($customerLeadSocialNetworksResponse) || (is_array($customerLeadSocialNetworksResponse) && empty($customerLeadSocialNetworksResponse))) {
            unset($this->CustomerLeadSocialNetworksResponse);
        } else {
            $this->CustomerLeadSocialNetworksResponse = $customerLeadSocialNetworksResponse;
        }
        return $this;
    }
    /**
     * Add item to CustomerLeadSocialNetworksResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomerLeadSocialNetworksResponse $item
     * @return \ArrayType\ArrayOfCustomerLeadSocialNetworksResponse
     */
    public function addToCustomerLeadSocialNetworksResponse(\StructType\CustomerLeadSocialNetworksResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomerLeadSocialNetworksResponse) {
            throw new \InvalidArgumentException(sprintf('The CustomerLeadSocialNetworksResponse property can only contain items of \StructType\CustomerLeadSocialNetworksResponse, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CustomerLeadSocialNetworksResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CustomerLeadSocialNetworksResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CustomerLeadSocialNetworksResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CustomerLeadSocialNetworksResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CustomerLeadSocialNetworksResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CustomerLeadSocialNetworksResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerLeadSocialNetworksResponse
     */
    public function getAttributeName()
    {
        return 'CustomerLeadSocialNetworksResponse';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCustomerLeadSocialNetworksResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
