<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetQualificationOverrideResponse ArrayType
 * @subpackage Arrays
 */
class ArrayOfGetQualificationOverrideResponse extends AbstractStructArrayBase
{
    /**
     * The GetQualificationOverrideResponse
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetQualificationOverrideResponse[]
     */
    public $GetQualificationOverrideResponse;
    /**
     * Constructor method for ArrayOfGetQualificationOverrideResponse
     * @uses ArrayOfGetQualificationOverrideResponse::setGetQualificationOverrideResponse()
     * @param \StructType\GetQualificationOverrideResponse[] $getQualificationOverrideResponse
     */
    public function __construct(array $getQualificationOverrideResponse = array())
    {
        $this
            ->setGetQualificationOverrideResponse($getQualificationOverrideResponse);
    }
    /**
     * Get GetQualificationOverrideResponse value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetQualificationOverrideResponse[]|null
     */
    public function getGetQualificationOverrideResponse()
    {
        return isset($this->GetQualificationOverrideResponse) ? $this->GetQualificationOverrideResponse : null;
    }
    /**
     * Set GetQualificationOverrideResponse value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetQualificationOverrideResponse[] $getQualificationOverrideResponse
     * @return \ArrayType\ArrayOfGetQualificationOverrideResponse
     */
    public function setGetQualificationOverrideResponse(array $getQualificationOverrideResponse = array())
    {
        foreach ($getQualificationOverrideResponse as $arrayOfGetQualificationOverrideResponseGetQualificationOverrideResponseItem) {
            // validation for constraint: itemType
            if (!$arrayOfGetQualificationOverrideResponseGetQualificationOverrideResponseItem instanceof \StructType\GetQualificationOverrideResponse) {
                throw new \InvalidArgumentException(sprintf('The GetQualificationOverrideResponse property can only contain items of \StructType\GetQualificationOverrideResponse, "%s" given', is_object($arrayOfGetQualificationOverrideResponseGetQualificationOverrideResponseItem) ? get_class($arrayOfGetQualificationOverrideResponseGetQualificationOverrideResponseItem) : gettype($arrayOfGetQualificationOverrideResponseGetQualificationOverrideResponseItem)), __LINE__);
            }
        }
        if (is_null($getQualificationOverrideResponse) || (is_array($getQualificationOverrideResponse) && empty($getQualificationOverrideResponse))) {
            unset($this->GetQualificationOverrideResponse);
        } else {
            $this->GetQualificationOverrideResponse = $getQualificationOverrideResponse;
        }
        return $this;
    }
    /**
     * Add item to GetQualificationOverrideResponse value
     * @throws \InvalidArgumentException
     * @param \StructType\GetQualificationOverrideResponse $item
     * @return \ArrayType\ArrayOfGetQualificationOverrideResponse
     */
    public function addToGetQualificationOverrideResponse(\StructType\GetQualificationOverrideResponse $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetQualificationOverrideResponse) {
            throw new \InvalidArgumentException(sprintf('The GetQualificationOverrideResponse property can only contain items of \StructType\GetQualificationOverrideResponse, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GetQualificationOverrideResponse[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetQualificationOverrideResponse|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetQualificationOverrideResponse|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetQualificationOverrideResponse|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetQualificationOverrideResponse|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetQualificationOverrideResponse|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetQualificationOverrideResponse
     */
    public function getAttributeName()
    {
        return 'GetQualificationOverrideResponse';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGetQualificationOverrideResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
