<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderImportDetail ArrayType
 * @subpackage Arrays
 */
class ArrayOfOrderImportDetail extends AbstractStructArrayBase
{
    /**
     * The OrderImportDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderImportDetail[]
     */
    public $OrderImportDetail;
    /**
     * Constructor method for ArrayOfOrderImportDetail
     * @uses ArrayOfOrderImportDetail::setOrderImportDetail()
     * @param \StructType\OrderImportDetail[] $orderImportDetail
     */
    public function __construct(array $orderImportDetail = array())
    {
        $this
            ->setOrderImportDetail($orderImportDetail);
    }
    /**
     * Get OrderImportDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderImportDetail[]|null
     */
    public function getOrderImportDetail()
    {
        return isset($this->OrderImportDetail) ? $this->OrderImportDetail : null;
    }
    /**
     * Set OrderImportDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderImportDetail[] $orderImportDetail
     * @return \ArrayType\ArrayOfOrderImportDetail
     */
    public function setOrderImportDetail(array $orderImportDetail = array())
    {
        foreach ($orderImportDetail as $arrayOfOrderImportDetailOrderImportDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderImportDetailOrderImportDetailItem instanceof \StructType\OrderImportDetail) {
                throw new \InvalidArgumentException(sprintf('The OrderImportDetail property can only contain items of \StructType\OrderImportDetail, "%s" given', is_object($arrayOfOrderImportDetailOrderImportDetailItem) ? get_class($arrayOfOrderImportDetailOrderImportDetailItem) : gettype($arrayOfOrderImportDetailOrderImportDetailItem)), __LINE__);
            }
        }
        if (is_null($orderImportDetail) || (is_array($orderImportDetail) && empty($orderImportDetail))) {
            unset($this->OrderImportDetail);
        } else {
            $this->OrderImportDetail = $orderImportDetail;
        }
        return $this;
    }
    /**
     * Add item to OrderImportDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderImportDetail $item
     * @return \ArrayType\ArrayOfOrderImportDetail
     */
    public function addToOrderImportDetail(\StructType\OrderImportDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderImportDetail) {
            throw new \InvalidArgumentException(sprintf('The OrderImportDetail property can only contain items of \StructType\OrderImportDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OrderImportDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderImportDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderImportDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderImportDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderImportDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderImportDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderImportDetail
     */
    public function getAttributeName()
    {
        return 'OrderImportDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfOrderImportDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
