<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOrderTotalByCurrency ArrayType
 * @subpackage Arrays
 */
class ArrayOfOrderTotalByCurrency extends AbstractStructArrayBase
{
    /**
     * The OrderTotalByCurrency
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OrderTotalByCurrency[]
     */
    public $OrderTotalByCurrency;
    /**
     * Constructor method for ArrayOfOrderTotalByCurrency
     * @uses ArrayOfOrderTotalByCurrency::setOrderTotalByCurrency()
     * @param \StructType\OrderTotalByCurrency[] $orderTotalByCurrency
     */
    public function __construct(array $orderTotalByCurrency = array())
    {
        $this
            ->setOrderTotalByCurrency($orderTotalByCurrency);
    }
    /**
     * Get OrderTotalByCurrency value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OrderTotalByCurrency[]|null
     */
    public function getOrderTotalByCurrency()
    {
        return isset($this->OrderTotalByCurrency) ? $this->OrderTotalByCurrency : null;
    }
    /**
     * Set OrderTotalByCurrency value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OrderTotalByCurrency[] $orderTotalByCurrency
     * @return \ArrayType\ArrayOfOrderTotalByCurrency
     */
    public function setOrderTotalByCurrency(array $orderTotalByCurrency = array())
    {
        foreach ($orderTotalByCurrency as $arrayOfOrderTotalByCurrencyOrderTotalByCurrencyItem) {
            // validation for constraint: itemType
            if (!$arrayOfOrderTotalByCurrencyOrderTotalByCurrencyItem instanceof \StructType\OrderTotalByCurrency) {
                throw new \InvalidArgumentException(sprintf('The OrderTotalByCurrency property can only contain items of \StructType\OrderTotalByCurrency, "%s" given', is_object($arrayOfOrderTotalByCurrencyOrderTotalByCurrencyItem) ? get_class($arrayOfOrderTotalByCurrencyOrderTotalByCurrencyItem) : gettype($arrayOfOrderTotalByCurrencyOrderTotalByCurrencyItem)), __LINE__);
            }
        }
        if (is_null($orderTotalByCurrency) || (is_array($orderTotalByCurrency) && empty($orderTotalByCurrency))) {
            unset($this->OrderTotalByCurrency);
        } else {
            $this->OrderTotalByCurrency = $orderTotalByCurrency;
        }
        return $this;
    }
    /**
     * Add item to OrderTotalByCurrency value
     * @throws \InvalidArgumentException
     * @param \StructType\OrderTotalByCurrency $item
     * @return \ArrayType\ArrayOfOrderTotalByCurrency
     */
    public function addToOrderTotalByCurrency(\StructType\OrderTotalByCurrency $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OrderTotalByCurrency) {
            throw new \InvalidArgumentException(sprintf('The OrderTotalByCurrency property can only contain items of \StructType\OrderTotalByCurrency, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OrderTotalByCurrency[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OrderTotalByCurrency|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OrderTotalByCurrency|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OrderTotalByCurrency|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OrderTotalByCurrency|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OrderTotalByCurrency|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OrderTotalByCurrency
     */
    public function getAttributeName()
    {
        return 'OrderTotalByCurrency';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfOrderTotalByCurrency
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
