<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfReportParameterRequest ArrayType
 * @subpackage Arrays
 */
class ArrayOfReportParameterRequest extends AbstractStructArrayBase
{
    /**
     * The ReportParameterRequest
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ReportParameterRequest[]
     */
    public $ReportParameterRequest;
    /**
     * Constructor method for ArrayOfReportParameterRequest
     * @uses ArrayOfReportParameterRequest::setReportParameterRequest()
     * @param \StructType\ReportParameterRequest[] $reportParameterRequest
     */
    public function __construct(array $reportParameterRequest = array())
    {
        $this
            ->setReportParameterRequest($reportParameterRequest);
    }
    /**
     * Get ReportParameterRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ReportParameterRequest[]|null
     */
    public function getReportParameterRequest()
    {
        return isset($this->ReportParameterRequest) ? $this->ReportParameterRequest : null;
    }
    /**
     * Set ReportParameterRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ReportParameterRequest[] $reportParameterRequest
     * @return \ArrayType\ArrayOfReportParameterRequest
     */
    public function setReportParameterRequest(array $reportParameterRequest = array())
    {
        foreach ($reportParameterRequest as $arrayOfReportParameterRequestReportParameterRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfReportParameterRequestReportParameterRequestItem instanceof \StructType\ReportParameterRequest) {
                throw new \InvalidArgumentException(sprintf('The ReportParameterRequest property can only contain items of \StructType\ReportParameterRequest, "%s" given', is_object($arrayOfReportParameterRequestReportParameterRequestItem) ? get_class($arrayOfReportParameterRequestReportParameterRequestItem) : gettype($arrayOfReportParameterRequestReportParameterRequestItem)), __LINE__);
            }
        }
        if (is_null($reportParameterRequest) || (is_array($reportParameterRequest) && empty($reportParameterRequest))) {
            unset($this->ReportParameterRequest);
        } else {
            $this->ReportParameterRequest = $reportParameterRequest;
        }
        return $this;
    }
    /**
     * Add item to ReportParameterRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\ReportParameterRequest $item
     * @return \ArrayType\ArrayOfReportParameterRequest
     */
    public function addToReportParameterRequest(\StructType\ReportParameterRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReportParameterRequest) {
            throw new \InvalidArgumentException(sprintf('The ReportParameterRequest property can only contain items of \StructType\ReportParameterRequest, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ReportParameterRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ReportParameterRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ReportParameterRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ReportParameterRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ReportParameterRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ReportParameterRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ReportParameterRequest
     */
    public function getAttributeName()
    {
        return 'ReportParameterRequest';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfReportParameterRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
