<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetVolumesRequest' => '\\StructType\\GetVolumesRequest',
            'ApiRequest' => '\\StructType\\ApiRequest',
            'RemoveApiWhitelistRequest' => '\\StructType\\RemoveApiWhitelistRequest',
            'CreateApiWhitelistRequest' => '\\StructType\\CreateApiWhitelistRequest',
            'GetApiWhitelistRequest' => '\\StructType\\GetApiWhitelistRequest',
            'DeleteOrderDetailRequest' => '\\StructType\\DeleteOrderDetailRequest',
            'UpdateOrderDetailRequest' => '\\StructType\\UpdateOrderDetailRequest',
            'CreateOrderDetailRequest' => '\\StructType\\CreateOrderDetailRequest',
            'SendEmailRequest' => '\\StructType\\SendEmailRequest',
            'SetItemKitMembersRequest' => '\\StructType\\SetItemKitMembersRequest',
            'ArrayOfKitMember' => '\\ArrayType\\ArrayOfKitMember',
            'KitMember' => '\\StructType\\KitMember',
            'GetFileContentsRequest' => '\\StructType\\GetFileContentsRequest',
            'GetFilesRequest' => '\\StructType\\GetFilesRequest',
            'ChargeGroupOrderCreditCardTokenRequest' => '\\StructType\\ChargeGroupOrderCreditCardTokenRequest',
            'ArrayOfGroupOrder' => '\\ArrayType\\ArrayOfGroupOrder',
            'GroupOrder' => '\\StructType\\GroupOrder',
            'DeleteCustomerExtendedRequest' => '\\StructType\\DeleteCustomerExtendedRequest',
            'UpdateCustomerExtendedRequest' => '\\StructType\\UpdateCustomerExtendedRequest',
            'CreateCustomerExtendedRequest' => '\\StructType\\CreateCustomerExtendedRequest',
            'UpdatePartyRequest' => '\\StructType\\UpdatePartyRequest',
            'PartyAddress' => '\\StructType\\PartyAddress',
            'CreatePartyRequest' => '\\StructType\\CreatePartyRequest',
            'CreateBillRequest' => '\\StructType\\CreateBillRequest',
            'BaseCreatePayoutRequest' => '\\StructType\\BaseCreatePayoutRequest',
            'CreatePayoutRequest' => '\\StructType\\CreatePayoutRequest',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'CreateCustomerInquiryRequest' => '\\StructType\\CreateCustomerInquiryRequest',
            'CreateCustomerFileRequest' => '\\StructType\\CreateCustomerFileRequest',
            'SetItemCountryRegionRequest' => '\\StructType\\SetItemCountryRegionRequest',
            'SetItemWarehouseRequest' => '\\StructType\\SetItemWarehouseRequest',
            'SetItemPriceRequest' => '\\StructType\\SetItemPriceRequest',
            'CreateItemRequest' => '\\StructType\\CreateItemRequest',
            'CreateCustomerWallItemRequest' => '\\StructType\\CreateCustomerWallItemRequest',
            'DeleteCustomerWallItemRequest' => '\\StructType\\DeleteCustomerWallItemRequest',
            'GetCustomerWallRequest' => '\\StructType\\GetCustomerWallRequest',
            'CreateCustomerLeadRequest' => '\\StructType\\CreateCustomerLeadRequest',
            'UpdateCustomerLeadRequest' => '\\StructType\\UpdateCustomerLeadRequest',
            'GetCustomerLeadsRequest' => '\\StructType\\GetCustomerLeadsRequest',
            'DeleteCustomerLeadRequest' => '\\StructType\\DeleteCustomerLeadRequest',
            'SetCustomerLeadSocialNetworksRequest' => '\\StructType\\SetCustomerLeadSocialNetworksRequest',
            'ArrayOfCustomerLeadSocialNetworkRequest' => '\\ArrayType\\ArrayOfCustomerLeadSocialNetworkRequest',
            'CustomerLeadSocialNetworkRequest' => '\\StructType\\CustomerLeadSocialNetworkRequest',
            'GetCustomerLeadSocialNetworksRequest' => '\\StructType\\GetCustomerLeadSocialNetworksRequest',
            'GetCustomerSocialNetworksRequest' => '\\StructType\\GetCustomerSocialNetworksRequest',
            'SetCustomerSocialNetworksRequest' => '\\StructType\\SetCustomerSocialNetworksRequest',
            'ArrayOfCustomerSocialNetworkRequest' => '\\ArrayType\\ArrayOfCustomerSocialNetworkRequest',
            'CustomerSocialNetworkRequest' => '\\StructType\\CustomerSocialNetworkRequest',
            'SetCustomerSiteRequest' => '\\StructType\\SetCustomerSiteRequest',
            'OptInSmsRequest' => '\\StructType\\OptInSmsRequest',
            'OptInEmailRequest' => '\\StructType\\OptInEmailRequest',
            'UpdateOrderRequest' => '\\StructType\\UpdateOrderRequest',
            'UpdateCustomerRequest' => '\\StructType\\UpdateCustomerRequest',
            'UpdateAutoOrderDetailRequest' => '\\StructType\\UpdateAutoOrderDetailRequest',
            'UpdateAutoOrderRequest' => '\\StructType\\UpdateAutoOrderRequest',
            'BaseCalculateOrderRequest' => '\\StructType\\BaseCalculateOrderRequest',
            'CalculateOrderRequest' => '\\StructType\\CalculateOrderRequest',
            'ArrayOfOrderDetailRequest' => '\\ArrayType\\ArrayOfOrderDetailRequest',
            'OrderDetailRequest' => '\\StructType\\OrderDetailRequest',
            'AdvancedAutoOptionsRequest' => '\\StructType\\AdvancedAutoOptionsRequest',
            'CreateAutoOrderRequest' => '\\StructType\\CreateAutoOrderRequest',
            'CreateOrderRequest' => '\\StructType\\CreateOrderRequest',
            'SetAccountDirectDepositRequest' => '\\StructType\\SetAccountDirectDepositRequest',
            'SetAccountWalletRequest' => '\\StructType\\SetAccountWalletRequest',
            'SetAccountCreditCardTokenRequest' => '\\StructType\\SetAccountCreditCardTokenRequest',
            'SetAccountCreditCardRequest' => '\\StructType\\SetAccountCreditCardRequest',
            'SetAccountCheckingRequest' => '\\StructType\\SetAccountCheckingRequest',
            'CreateOrderImportRequest' => '\\StructType\\CreateOrderImportRequest',
            'ArrayOfOrderImportDetail' => '\\ArrayType\\ArrayOfOrderImportDetail',
            'OrderImportDetail' => '\\StructType\\OrderImportDetail',
            'CreateCustomerRequest' => '\\StructType\\CreateCustomerRequest',
            'TransactionalRequest' => '\\StructType\\TransactionalRequest',
            'ArrayOfApiRequest' => '\\ArrayType\\ArrayOfApiRequest',
            'BaseCreateExpectedPaymentRequest' => '\\StructType\\BaseCreateExpectedPaymentRequest',
            'CreateExpectedBankWireRequest' => '\\StructType\\CreateExpectedBankWireRequest',
            'CreateExpectedCODRequest' => '\\StructType\\CreateExpectedCODRequest',
            'CreateExpectedPaymentRequest' => '\\StructType\\CreateExpectedPaymentRequest',
            'BaseAuthorizeOnlyCreditCardTokenRequest' => '\\StructType\\BaseAuthorizeOnlyCreditCardTokenRequest',
            'AuthorizeOnlyCreditCardTokenOnFileRequest' => '\\StructType\\AuthorizeOnlyCreditCardTokenOnFileRequest',
            'AuthorizeOnlyCreditCardTokenRequest' => '\\StructType\\AuthorizeOnlyCreditCardTokenRequest',
            'BaseCreatePaymentRequest' => '\\StructType\\BaseCreatePaymentRequest',
            'BaseChargeWalletAccountRequest' => '\\StructType\\BaseChargeWalletAccountRequest',
            'ChargeWalletAccountRequest' => '\\StructType\\ChargeWalletAccountRequest',
            'ChargeWalletAccountOnFileRequest' => '\\StructType\\ChargeWalletAccountOnFileRequest',
            'BaseDebitBankAccountRequest' => '\\StructType\\BaseDebitBankAccountRequest',
            'DebitBankAccountOnFileRequest' => '\\StructType\\DebitBankAccountOnFileRequest',
            'DebitBankAccountRequest' => '\\StructType\\DebitBankAccountRequest',
            'RefundPriorWalletChargeRequest' => '\\StructType\\RefundPriorWalletChargeRequest',
            'CreatePaymentRequest' => '\\StructType\\CreatePaymentRequest',
            'CreatePaymentWalletRequest' => '\\StructType\\CreatePaymentWalletRequest',
            'ChargePriorAuthorizationRequest' => '\\StructType\\ChargePriorAuthorizationRequest',
            'BaseCreatePaymentCreditCardRequest' => '\\StructType\\BaseCreatePaymentCreditCardRequest',
            'CreatePaymentCreditCardRequest' => '\\StructType\\CreatePaymentCreditCardRequest',
            'BaseChargeCreditCardRequest' => '\\StructType\\BaseChargeCreditCardRequest',
            'ChargeCreditCardTokenOnFileRequest' => '\\StructType\\ChargeCreditCardTokenOnFileRequest',
            'ChargeCreditCardTokenRequest' => '\\StructType\\ChargeCreditCardTokenRequest',
            'ChargeCreditCardOnFileRequest' => '\\StructType\\ChargeCreditCardOnFileRequest',
            'ChargeCreditCardRequest' => '\\StructType\\ChargeCreditCardRequest',
            'RefundPriorCreditCardChargeRequest' => '\\StructType\\RefundPriorCreditCardChargeRequest',
            'GetVolumesResponse' => '\\StructType\\GetVolumesResponse',
            'ApiResponse' => '\\StructType\\ApiResponse',
            'ApiResult' => '\\StructType\\ApiResult',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'RemoveApiWhitelistResponse' => '\\StructType\\RemoveApiWhitelistResponse',
            'CreateApiWhitelistResponse' => '\\StructType\\CreateApiWhitelistResponse',
            'GetApiWhitelistResponse' => '\\StructType\\GetApiWhitelistResponse',
            'ArrayOfApiWhitelistResponse' => '\\ArrayType\\ArrayOfApiWhitelistResponse',
            'ApiWhitelistResponse' => '\\StructType\\ApiWhitelistResponse',
            'DeleteOrderDetailResponse' => '\\StructType\\DeleteOrderDetailResponse',
            'UpdateOrderDetailResponse' => '\\StructType\\UpdateOrderDetailResponse',
            'CreateOrderDetailResponse' => '\\StructType\\CreateOrderDetailResponse',
            'SendEmailResponse' => '\\StructType\\SendEmailResponse',
            'SetItemKitMembersResponse' => '\\StructType\\SetItemKitMembersResponse',
            'GetFileContentsResponse' => '\\StructType\\GetFileContentsResponse',
            'GetFilesResponse' => '\\StructType\\GetFilesResponse',
            'ArrayOfCustomerFilesResponse' => '\\ArrayType\\ArrayOfCustomerFilesResponse',
            'CustomerFilesResponse' => '\\StructType\\CustomerFilesResponse',
            'ChargeGroupOrderCreditCardTokenResponse' => '\\StructType\\ChargeGroupOrderCreditCardTokenResponse',
            'ArrayOfPaymentsResponse' => '\\ArrayType\\ArrayOfPaymentsResponse',
            'PaymentsResponse' => '\\StructType\\PaymentsResponse',
            'DeleteCustomerExtendedResponse' => '\\StructType\\DeleteCustomerExtendedResponse',
            'UpdateCustomerExtendedResponse' => '\\StructType\\UpdateCustomerExtendedResponse',
            'CreateCustomerExtendedResponse' => '\\StructType\\CreateCustomerExtendedResponse',
            'UpdatePartyResponse' => '\\StructType\\UpdatePartyResponse',
            'CreatePartyResponse' => '\\StructType\\CreatePartyResponse',
            'CreateBillResponse' => '\\StructType\\CreateBillResponse',
            'CreatePayoutResponse' => '\\StructType\\CreatePayoutResponse',
            'CreateCustomerInquiryResponse' => '\\StructType\\CreateCustomerInquiryResponse',
            'CreateCustomerFileResponse' => '\\StructType\\CreateCustomerFileResponse',
            'SetItemCountryRegionResponse' => '\\StructType\\SetItemCountryRegionResponse',
            'GetItemCountryRegionResponse' => '\\StructType\\GetItemCountryRegionResponse',
            'ArrayOfItemCountryRegionResponse' => '\\ArrayType\\ArrayOfItemCountryRegionResponse',
            'ItemCountryRegionResponse' => '\\StructType\\ItemCountryRegionResponse',
            'UpdateItemResponse' => '\\StructType\\UpdateItemResponse',
            'CreateItemResponse' => '\\StructType\\CreateItemResponse',
            'GetCustomerWallResponse' => '\\StructType\\GetCustomerWallResponse',
            'ArrayOfCustomerWallItemResponse' => '\\ArrayType\\ArrayOfCustomerWallItemResponse',
            'CustomerWallItemResponse' => '\\StructType\\CustomerWallItemResponse',
            'DeleteCustomerWallItemResponse' => '\\StructType\\DeleteCustomerWallItemResponse',
            'CreateCustomerWallItemResponse' => '\\StructType\\CreateCustomerWallItemResponse',
            'UpdateCustomerLeadResponse' => '\\StructType\\UpdateCustomerLeadResponse',
            'GetCustomerLeadsResponse' => '\\StructType\\GetCustomerLeadsResponse',
            'ArrayOfCustomerLeadsResponse' => '\\ArrayType\\ArrayOfCustomerLeadsResponse',
            'CustomerLeadsResponse' => '\\StructType\\CustomerLeadsResponse',
            'DeleteCustomerLeadResponse' => '\\StructType\\DeleteCustomerLeadResponse',
            'CreateCustomerLeadResponse' => '\\StructType\\CreateCustomerLeadResponse',
            'SetCustomerLeadSocialNetworksResponse' => '\\StructType\\SetCustomerLeadSocialNetworksResponse',
            'GetCustomerLeadSocialNetworksResponse' => '\\StructType\\GetCustomerLeadSocialNetworksResponse',
            'ArrayOfCustomerLeadSocialNetworksResponse' => '\\ArrayType\\ArrayOfCustomerLeadSocialNetworksResponse',
            'CustomerLeadSocialNetworksResponse' => '\\StructType\\CustomerLeadSocialNetworksResponse',
            'SetCustomerSocialNetworksResponse' => '\\StructType\\SetCustomerSocialNetworksResponse',
            'GetCustomerSocialNetworksResponse' => '\\StructType\\GetCustomerSocialNetworksResponse',
            'ArrayOfCustomerSocialNetworksResponse' => '\\ArrayType\\ArrayOfCustomerSocialNetworksResponse',
            'CustomerSocialNetworksResponse' => '\\StructType\\CustomerSocialNetworksResponse',
            'SetCustomerSiteResponse' => '\\StructType\\SetCustomerSiteResponse',
            'UpdateCustomerResponse' => '\\StructType\\UpdateCustomerResponse',
            'UpdateOrderResponse' => '\\StructType\\UpdateOrderResponse',
            'BaseCalculateOrderResponse' => '\\StructType\\BaseCalculateOrderResponse',
            'CalculateOrderResponse' => '\\StructType\\CalculateOrderResponse',
            'ArrayOfOrderDetailResponse' => '\\ArrayType\\ArrayOfOrderDetailResponse',
            'OrderDetailResponse' => '\\StructType\\OrderDetailResponse',
            'ArrayOfShipMethodResponse' => '\\ArrayType\\ArrayOfShipMethodResponse',
            'ShipMethodResponse' => '\\StructType\\ShipMethodResponse',
            'CreateAutoOrderResponse' => '\\StructType\\CreateAutoOrderResponse',
            'CreateOrderResponse' => '\\StructType\\CreateOrderResponse',
            'CreateCustomerResponse' => '\\StructType\\CreateCustomerResponse',
            'SetAccountResponse' => '\\StructType\\SetAccountResponse',
            'CreateOrderImportResponse' => '\\StructType\\CreateOrderImportResponse',
            'TransactionalResponse' => '\\StructType\\TransactionalResponse',
            'ArrayOfApiResponse' => '\\ArrayType\\ArrayOfApiResponse',
            'BaseCreateExpectedPaymentResponse' => '\\StructType\\BaseCreateExpectedPaymentResponse',
            'CreateExpectedBankWireResponse' => '\\StructType\\CreateExpectedBankWireResponse',
            'CreateExpectedCODResponse' => '\\StructType\\CreateExpectedCODResponse',
            'CreateExpectedPaymentResponse' => '\\StructType\\CreateExpectedPaymentResponse',
            'AuthorizeOnlyCreditCardResponse' => '\\StructType\\AuthorizeOnlyCreditCardResponse',
            'BaseCreatePaymentResponse' => '\\StructType\\BaseCreatePaymentResponse',
            'CreatePaymentCreditCardResponse' => '\\StructType\\CreatePaymentCreditCardResponse',
            'ChargeCreditCardResponse' => '\\StructType\\ChargeCreditCardResponse',
            'RefundPriorCreditCardChargeResponse' => '\\StructType\\RefundPriorCreditCardChargeResponse',
            'CreatePaymentResponse' => '\\StructType\\CreatePaymentResponse',
            'DebitBankAccountResponse' => '\\StructType\\DebitBankAccountResponse',
            'RefundPriorWalletChargeResponse' => '\\StructType\\RefundPriorWalletChargeResponse',
            'ArrayOfVolumeResponse' => '\\ArrayType\\ArrayOfVolumeResponse',
            'VolumeResponse' => '\\StructType\\VolumeResponse',
            'ApiAuthentication' => '\\StructType\\ApiAuthentication',
            'GetWarehousesRequest' => '\\StructType\\GetWarehousesRequest',
            'GetWarehousesResponse' => '\\StructType\\GetWarehousesResponse',
            'ArrayOfWarehouseResponse' => '\\ArrayType\\ArrayOfWarehouseResponse',
            'WarehouseResponse' => '\\StructType\\WarehouseResponse',
            'LoginCustomerRequest' => '\\StructType\\LoginCustomerRequest',
            'LoginCustomerResponse' => '\\StructType\\LoginCustomerResponse',
            'MergeCustomerRequest' => '\\StructType\\MergeCustomerRequest',
            'MergeCustomerResponse' => '\\StructType\\MergeCustomerResponse',
            'MoveEmailRequest' => '\\StructType\\MoveEmailRequest',
            'MoveEmailResponse' => '\\StructType\\MoveEmailResponse',
            'OptInEmailResponse' => '\\StructType\\OptInEmailResponse',
            'OptInPushNotificationRequest' => '\\StructType\\OptInPushNotificationRequest',
            'OptInPushNotificationResponse' => '\\StructType\\OptInPushNotificationResponse',
            'OptInSmsResponse' => '\\StructType\\OptInSmsResponse',
            'OptOutEmailRequest' => '\\StructType\\OptOutEmailRequest',
            'OptOutEmailResponse' => '\\StructType\\OptOutEmailResponse',
            'OptOutPushNotificationRequest' => '\\StructType\\OptOutPushNotificationRequest',
            'OptOutPushNotificationResponse' => '\\StructType\\OptOutPushNotificationResponse',
            'OptOutSmsRequest' => '\\StructType\\OptOutSmsRequest',
            'OptOutSmsResponse' => '\\StructType\\OptOutSmsResponse',
            'PlaceBinaryNodeRequest' => '\\StructType\\PlaceBinaryNodeRequest',
            'PlaceBinaryNodeResponse' => '\\StructType\\PlaceBinaryNodeResponse',
            'PlaceEnrollerNodeRequest' => '\\StructType\\PlaceEnrollerNodeRequest',
            'PlaceEnrollerNodeResponse' => '\\StructType\\PlaceEnrollerNodeResponse',
            'PlaceMatrixNodeRequest' => '\\StructType\\PlaceMatrixNodeRequest',
            'PlaceMatrixNodeResponse' => '\\StructType\\PlaceMatrixNodeResponse',
            'PlaceStackNodeRequest' => '\\StructType\\PlaceStackNodeRequest',
            'PlaceStackNodeResponse' => '\\StructType\\PlaceStackNodeResponse',
            'PlaceUniLevelNodeRequest' => '\\StructType\\PlaceUniLevelNodeRequest',
            'PlaceUniLevelNodeResponse' => '\\StructType\\PlaceUniLevelNodeResponse',
            'RefreshSandboxRequest' => '\\StructType\\RefreshSandboxRequest',
            'RefreshSandboxResponse' => '\\StructType\\RefreshSandboxResponse',
            'Sandbox' => '\\StructType\\Sandbox',
            'RemovePartyGuestsRequest' => '\\StructType\\RemovePartyGuestsRequest',
            'RemovePartyGuestsResponse' => '\\StructType\\RemovePartyGuestsResponse',
            'SendSmsRequest' => '\\StructType\\SendSmsRequest',
            'SendSmsResponse' => '\\StructType\\SendSmsResponse',
            'SetBinaryPreferenceRequest' => '\\StructType\\SetBinaryPreferenceRequest',
            'SetBinaryPreferenceResponse' => '\\StructType\\SetBinaryPreferenceResponse',
            'SetCustomerSiteImageRequest' => '\\StructType\\SetCustomerSiteImageRequest',
            'SetCustomerSiteImageResponse' => '\\StructType\\SetCustomerSiteImageResponse',
            'SetGuestSocialNetworksRequest' => '\\StructType\\SetGuestSocialNetworksRequest',
            'ArrayOfGuestSocialNetworkRequest' => '\\ArrayType\\ArrayOfGuestSocialNetworkRequest',
            'GuestSocialNetworkRequest' => '\\StructType\\GuestSocialNetworkRequest',
            'SetGuestSocialNetworksResponse' => '\\StructType\\SetGuestSocialNetworksResponse',
            'SetImageFileRequest' => '\\StructType\\SetImageFileRequest',
            'SetImageFileResponse' => '\\StructType\\SetImageFileResponse',
            'SetItemImageRequest' => '\\StructType\\SetItemImageRequest',
            'SetItemImageResponse' => '\\StructType\\SetItemImageResponse',
            'SetItemPriceResponse' => '\\StructType\\SetItemPriceResponse',
            'SetItemWarehouseResponse' => '\\StructType\\SetItemWarehouseResponse',
            'SetQualificationOverrideRequest' => '\\StructType\\SetQualificationOverrideRequest',
            'SetQualificationOverrideResponse' => '\\StructType\\SetQualificationOverrideResponse',
            'SetSessionRequest' => '\\StructType\\SetSessionRequest',
            'SetSessionResponse' => '\\StructType\\SetSessionResponse',
            'StartSandboxRequest' => '\\StructType\\StartSandboxRequest',
            'StartSandboxResponse' => '\\StructType\\StartSandboxResponse',
            'StopSandboxRequest' => '\\StructType\\StopSandboxRequest',
            'StopSandboxResponse' => '\\StructType\\StopSandboxResponse',
            'UpdateCalendarItemRequest' => '\\StructType\\UpdateCalendarItemRequest',
            'UpdateCalendarItemResponse' => '\\StructType\\UpdateCalendarItemResponse',
            'UpdateCustomerContactRequest' => '\\StructType\\UpdateCustomerContactRequest',
            'UpdateCustomerContactResponse' => '\\StructType\\UpdateCustomerContactResponse',
            'UpdateEmailStatusRequest' => '\\StructType\\UpdateEmailStatusRequest',
            'UpdateEmailStatusResponse' => '\\StructType\\UpdateEmailStatusResponse',
            'UpdateEmailTemplateRequest' => '\\StructType\\UpdateEmailTemplateRequest',
            'UpdateEmailTemplateResponse' => '\\StructType\\UpdateEmailTemplateResponse',
            'UpdateEntityRequest' => '\\StructType\\UpdateEntityRequest',
            'Entity' => '\\StructType\\Entity',
            'ArrayOfProperty' => '\\ArrayType\\ArrayOfProperty',
            'Property' => '\\StructType\\Property',
            'ArrayOfNavigation' => '\\ArrayType\\ArrayOfNavigation',
            'Navigation' => '\\StructType\\Navigation',
            'UpdateEntityResponse' => '\\StructType\\UpdateEntityResponse',
            'UpdateGuestRequest' => '\\StructType\\UpdateGuestRequest',
            'UpdateGuestResponse' => '\\StructType\\UpdateGuestResponse',
            'UpdateItemRequest' => '\\StructType\\UpdateItemRequest',
            'UpdateMailFolderRequest' => '\\StructType\\UpdateMailFolderRequest',
            'UpdateMailFolderResponse' => '\\StructType\\UpdateMailFolderResponse',
            'UpdateWebCategoryRequest' => '\\StructType\\UpdateWebCategoryRequest',
            'UpdateWebCategoryResponse' => '\\StructType\\UpdateWebCategoryResponse',
            'ValidateRequest' => '\\StructType\\ValidateRequest',
            'IsTaxIDAvailableValidateRequest' => '\\StructType\\IsTaxIDAvailableValidateRequest',
            'IsLoginNameAvailableValidateRequest' => '\\StructType\\IsLoginNameAvailableValidateRequest',
            'IsEnrollerChildValidateRequest' => '\\StructType\\IsEnrollerChildValidateRequest',
            'IsUniLevelChildValidateRequest' => '\\StructType\\IsUniLevelChildValidateRequest',
            'IsMatrixChildValidateRequest' => '\\StructType\\IsMatrixChildValidateRequest',
            'ValidateResponse' => '\\StructType\\ValidateResponse',
            'VerifyAddressRequest' => '\\StructType\\VerifyAddressRequest',
            'VerifyAddressResponse' => '\\StructType\\VerifyAddressResponse',
            'GetOrderInvoiceRequest' => '\\StructType\\GetOrderInvoiceRequest',
            'GetOrderInvoiceResponse' => '\\StructType\\GetOrderInvoiceResponse',
            'AddPartyGuestsRequest' => '\\StructType\\AddPartyGuestsRequest',
            'AddPartyGuestsResponse' => '\\StructType\\AddPartyGuestsResponse',
            'AddProductsToCategoryRequest' => '\\StructType\\AddProductsToCategoryRequest',
            'AddProductsToCategoryResponse' => '\\StructType\\AddProductsToCategoryResponse',
            'AdjustInventoryRequest' => '\\StructType\\AdjustInventoryRequest',
            'AdjustInventoryResponse' => '\\StructType\\AdjustInventoryResponse',
            'AppendCustomerNotesRequest' => '\\StructType\\AppendCustomerNotesRequest',
            'AppendCustomerNotesResponse' => '\\StructType\\AppendCustomerNotesResponse',
            'AuthenticateCustomerRequest' => '\\StructType\\AuthenticateCustomerRequest',
            'AuthenticateCustomerResponse' => '\\StructType\\AuthenticateCustomerResponse',
            'AuthenticateUserRequest' => '\\StructType\\AuthenticateUserRequest',
            'AuthenticateUserResponse' => '\\StructType\\AuthenticateUserResponse',
            'ChangeAutoOrderStatusRequest' => '\\StructType\\ChangeAutoOrderStatusRequest',
            'ChangeAutoOrderStatusResponse' => '\\StructType\\ChangeAutoOrderStatusResponse',
            'ChangeOrderStatusRequest' => '\\StructType\\ChangeOrderStatusRequest',
            'ChangeOrderStatusResponse' => '\\StructType\\ChangeOrderStatusResponse',
            'ChangeOrderStatusBatchRequest' => '\\StructType\\ChangeOrderStatusBatchRequest',
            'ArrayOfOrderBatchDetailRequest' => '\\ArrayType\\ArrayOfOrderBatchDetailRequest',
            'OrderBatchDetailRequest' => '\\StructType\\OrderBatchDetailRequest',
            'ChangeOrderStatusBatchResponse' => '\\StructType\\ChangeOrderStatusBatchResponse',
            'ChargeWalletAccountResponse' => '\\StructType\\ChargeWalletAccountResponse',
            'UpdateAutoOrderResponse' => '\\StructType\\UpdateAutoOrderResponse',
            'UpdateAutoOrderDetailResponse' => '\\StructType\\UpdateAutoOrderDetailResponse',
            'CreateCalendarItemRequest' => '\\StructType\\CreateCalendarItemRequest',
            'CreateCalendarItemResponse' => '\\StructType\\CreateCalendarItemResponse',
            'CreateCustomerBalanceAdjustmentRequest' => '\\StructType\\CreateCustomerBalanceAdjustmentRequest',
            'CreateCustomerBalanceAdjustmentResponse' => '\\StructType\\CreateCustomerBalanceAdjustmentResponse',
            'CreateCustomerContactRequest' => '\\StructType\\CreateCustomerContactRequest',
            'CreateCustomerContactResponse' => '\\StructType\\CreateCustomerContactResponse',
            'CreateEmailRequest' => '\\StructType\\CreateEmailRequest',
            'ArrayOfEmailAttachment' => '\\ArrayType\\ArrayOfEmailAttachment',
            'EmailAttachment' => '\\StructType\\EmailAttachment',
            'ArrayOfForwardedAttachment' => '\\ArrayType\\ArrayOfForwardedAttachment',
            'ForwardedAttachment' => '\\StructType\\ForwardedAttachment',
            'CreateEmailResponse' => '\\StructType\\CreateEmailResponse',
            'CreateEmailTemplateRequest' => '\\StructType\\CreateEmailTemplateRequest',
            'CreateEmailTemplateResponse' => '\\StructType\\CreateEmailTemplateResponse',
            'CreateEntityRequest' => '\\StructType\\CreateEntityRequest',
            'CreateEntityResponse' => '\\StructType\\CreateEntityResponse',
            'CreateExtendedDbSchemeRequest' => '\\StructType\\CreateExtendedDbSchemeRequest',
            'Schema' => '\\StructType\\Schema',
            'ArrayOfEntity' => '\\ArrayType\\ArrayOfEntity',
            'CreateExtendedDbSchemaResponse' => '\\StructType\\CreateExtendedDbSchemaResponse',
            'CreateGuestRequest' => '\\StructType\\CreateGuestRequest',
            'CreateGuestResponse' => '\\StructType\\CreateGuestResponse',
            'CreateMailFolderRequest' => '\\StructType\\CreateMailFolderRequest',
            'CreateMailFolderResponse' => '\\StructType\\CreateMailFolderResponse',
            'CreatePaymentCheckRequest' => '\\StructType\\CreatePaymentCheckRequest',
            'CreatePaymentCheckResponse' => '\\StructType\\CreatePaymentCheckResponse',
            'CreatePaymentPointAccountRequest' => '\\StructType\\CreatePaymentPointAccountRequest',
            'CreatePaymentPointAccountResponse' => '\\StructType\\CreatePaymentPointAccountResponse',
            'CreatePointTransactionRequest' => '\\StructType\\CreatePointTransactionRequest',
            'CreatePointTransactionResponse' => '\\StructType\\CreatePointTransactionResponse',
            'CreateVendorBillRequest' => '\\StructType\\CreateVendorBillRequest',
            'CreateVendorBillResponse' => '\\StructType\\CreateVendorBillResponse',
            'CreateWarehouseRequest' => '\\StructType\\CreateWarehouseRequest',
            'CreateWarehouseResponse' => '\\StructType\\CreateWarehouseResponse',
            'CreateWebCategoryRequest' => '\\StructType\\CreateWebCategoryRequest',
            'CreateWebCategoryResponse' => '\\StructType\\CreateWebCategoryResponse',
            'DeleteCalendarItemRequest' => '\\StructType\\DeleteCalendarItemRequest',
            'DeleteCalendarItemResponse' => '\\StructType\\DeleteCalendarItemResponse',
            'DeleteCustomerContactRequest' => '\\StructType\\DeleteCustomerContactRequest',
            'DeleteCustomerContactResponse' => '\\StructType\\DeleteCustomerContactResponse',
            'DeleteEmailRequest' => '\\StructType\\DeleteEmailRequest',
            'DeleteEmailResponse' => '\\StructType\\DeleteEmailResponse',
            'DeleteEmailTemplateRequest' => '\\StructType\\DeleteEmailTemplateRequest',
            'DeleteEmailTemplateResponse' => '\\StructType\\DeleteEmailTemplateResponse',
            'DeleteEntityRequest' => '\\StructType\\DeleteEntityRequest',
            'DeleteEntityResponse' => '\\StructType\\DeleteEntityResponse',
            'DeleteSchemaRequest' => '\\StructType\\DeleteSchemaRequest',
            'DeleteSchemaResponse' => '\\StructType\\DeleteSchemaResponse',
            'DeleteMailFolderRequest' => '\\StructType\\DeleteMailFolderRequest',
            'DeleteMailFolderResponse' => '\\StructType\\DeleteMailFolderResponse',
            'DeleteProductFromCategoryRequest' => '\\StructType\\DeleteProductFromCategoryRequest',
            'DeleteProductFromCategoryResponse' => '\\StructType\\DeleteProductFromCategoryResponse',
            'DeleteQualificationOverrideRequest' => '\\StructType\\DeleteQualificationOverrideRequest',
            'DeleteQualificationOverrideResponse' => '\\StructType\\DeleteQualificationOverrideResponse',
            'DeleteWebCategoryRequest' => '\\StructType\\DeleteWebCategoryRequest',
            'DeleteWebCategoryResponse' => '\\StructType\\DeleteWebCategoryResponse',
            'DequeueCustomerEventsRequest' => '\\StructType\\DequeueCustomerEventsRequest',
            'DequeueCustomerEventsResponse' => '\\StructType\\DequeueCustomerEventsResponse',
            'ArrayOfCustomerEventResponse' => '\\ArrayType\\ArrayOfCustomerEventResponse',
            'CustomerEventResponse' => '\\StructType\\CustomerEventResponse',
            'ArrayOfCustomerEventField' => '\\ArrayType\\ArrayOfCustomerEventField',
            'CustomerEventField' => '\\StructType\\CustomerEventField',
            'EmptyMailFolderRequest' => '\\StructType\\EmptyMailFolderRequest',
            'EmptyMailFolderResponse' => '\\StructType\\EmptyMailFolderResponse',
            'EnsureMailFoldersRequest' => '\\StructType\\EnsureMailFoldersRequest',
            'EnsureMailFoldersResponse' => '\\StructType\\EnsureMailFoldersResponse',
            'FireResponderRequest' => '\\StructType\\FireResponderRequest',
            'FireResponderResponse' => '\\StructType\\FireResponderResponse',
            'FundPaymentCardRequest' => '\\StructType\\FundPaymentCardRequest',
            'FundPaymentCardResponse' => '\\StructType\\FundPaymentCardResponse',
            'GetAccountDirectDepositRequest' => '\\StructType\\GetAccountDirectDepositRequest',
            'GetAccountDirectDepositResponse' => '\\StructType\\GetAccountDirectDepositResponse',
            'GetAutoOrdersRequest' => '\\StructType\\GetAutoOrdersRequest',
            'GetAutoOrdersResponse' => '\\StructType\\GetAutoOrdersResponse',
            'ArrayOfAutoOrderResponse' => '\\ArrayType\\ArrayOfAutoOrderResponse',
            'AutoOrderResponse' => '\\StructType\\AutoOrderResponse',
            'ArrayOfAutoOrderDetailResponse' => '\\ArrayType\\ArrayOfAutoOrderDetailResponse',
            'AutoOrderDetailResponse' => '\\StructType\\AutoOrderDetailResponse',
            'GetBinaryPreferenceRequest' => '\\StructType\\GetBinaryPreferenceRequest',
            'GetBinaryPreferenceResponse' => '\\StructType\\GetBinaryPreferenceResponse',
            'GetLanguagesRequest' => '\\StructType\\GetLanguagesRequest',
            'GetLanguagesResponse' => '\\StructType\\GetLanguagesResponse',
            'ArrayOfLanguageResponse' => '\\ArrayType\\ArrayOfLanguageResponse',
            'LanguageResponse' => '\\StructType\\LanguageResponse',
            'GetCompanyNewsRequest' => '\\StructType\\GetCompanyNewsRequest',
            'GetCompanyNewsResponse' => '\\StructType\\GetCompanyNewsResponse',
            'ArrayOfCompanyNewsResponse' => '\\ArrayType\\ArrayOfCompanyNewsResponse',
            'CompanyNewsResponse' => '\\StructType\\CompanyNewsResponse',
            'GetCompanyNewsItemRequest' => '\\StructType\\GetCompanyNewsItemRequest',
            'GetCompanyNewsItemResponse' => '\\StructType\\GetCompanyNewsItemResponse',
            'ArrayOfDepartmentInfo' => '\\ArrayType\\ArrayOfDepartmentInfo',
            'DepartmentInfo' => '\\StructType\\DepartmentInfo',
            'GetCountryRegionsRequest' => '\\StructType\\GetCountryRegionsRequest',
            'GetCountryRegionsResponse' => '\\StructType\\GetCountryRegionsResponse',
            'ArrayOfCountryResponse' => '\\ArrayType\\ArrayOfCountryResponse',
            'CountryResponse' => '\\StructType\\CountryResponse',
            'ArrayOfRegionResponse' => '\\ArrayType\\ArrayOfRegionResponse',
            'RegionResponse' => '\\StructType\\RegionResponse',
            'GetCustomerBalancesRequest' => '\\StructType\\GetCustomerBalancesRequest',
            'GetCustomerBalancesResponse' => '\\StructType\\GetCustomerBalancesResponse',
            'ArrayOfCustomerBalanceResponse' => '\\ArrayType\\ArrayOfCustomerBalanceResponse',
            'CustomerBalanceResponse' => '\\StructType\\CustomerBalanceResponse',
            'GetCustomerBillingRequest' => '\\StructType\\GetCustomerBillingRequest',
            'GetCustomerBillingResponse' => '\\StructType\\GetCustomerBillingResponse',
            'CreditCardAccountResponse' => '\\StructType\\CreditCardAccountResponse',
            'BankAccountResponse' => '\\StructType\\BankAccountResponse',
            'WalletAccountResponse' => '\\StructType\\WalletAccountResponse',
            'GetCustomerExtendedRequest' => '\\StructType\\GetCustomerExtendedRequest',
            'GetCustomerExtendedResponse' => '\\StructType\\GetCustomerExtendedResponse',
            'ArrayOfCustomerExtendedResponse' => '\\ArrayType\\ArrayOfCustomerExtendedResponse',
            'CustomerExtendedResponse' => '\\StructType\\CustomerExtendedResponse',
            'GetCustomerNotesRequest' => '\\StructType\\GetCustomerNotesRequest',
            'GetCustomerNotesResponse' => '\\StructType\\GetCustomerNotesResponse',
            'ArrayOfCustomerNotesResponse' => '\\ArrayType\\ArrayOfCustomerNotesResponse',
            'CustomerNotesResponse' => '\\StructType\\CustomerNotesResponse',
            'GetCustomersRequest' => '\\StructType\\GetCustomersRequest',
            'GetCustomersResponse' => '\\StructType\\GetCustomersResponse',
            'ArrayOfCustomerResponse' => '\\ArrayType\\ArrayOfCustomerResponse',
            'CustomerResponse' => '\\StructType\\CustomerResponse',
            'GetCustomerSiteRequest' => '\\StructType\\GetCustomerSiteRequest',
            'GetCustomerSiteResponse' => '\\StructType\\GetCustomerSiteResponse',
            'GetCustomReportRequest' => '\\StructType\\GetCustomReportRequest',
            'ArrayOfParameterRequest' => '\\ArrayType\\ArrayOfParameterRequest',
            'ParameterRequest' => '\\StructType\\ParameterRequest',
            'GetCustomReportResponse' => '\\StructType\\GetCustomReportResponse',
            'ReportData' => '\\StructType\\ReportData',
            'GetDownlineRequest' => '\\StructType\\GetDownlineRequest',
            'ArrayOfVolumeFilter' => '\\ArrayType\\ArrayOfVolumeFilter',
            'VolumeFilter' => '\\StructType\\VolumeFilter',
            'NodeResponse' => '\\StructType\\NodeResponse',
            'ArrayOfNodeResponse' => '\\ArrayType\\ArrayOfNodeResponse',
            'GetDownlineResponse' => '\\StructType\\GetDownlineResponse',
            'GetEmailAttachmentRequest' => '\\StructType\\GetEmailAttachmentRequest',
            'GetEmailAttachmentResponse' => '\\StructType\\GetEmailAttachmentResponse',
            'GetEntityRequest' => '\\StructType\\GetEntityRequest',
            'GetEntityResponse' => '\\StructType\\GetEntityResponse',
            'GetSchemaRequest' => '\\StructType\\GetSchemaRequest',
            'GetSchemaResponse' => '\\StructType\\GetSchemaResponse',
            'GetGuestsRequest' => '\\StructType\\GetGuestsRequest',
            'GuestResponse' => '\\StructType\\GuestResponse',
            'ArrayOfGuestResponse' => '\\ArrayType\\ArrayOfGuestResponse',
            'GetGuestsResponse' => '\\StructType\\GetGuestsResponse',
            'GetGuestSocialNetworksRequest' => '\\StructType\\GetGuestSocialNetworksRequest',
            'GuestSocialNetworksResponse' => '\\StructType\\GuestSocialNetworksResponse',
            'ArrayOfGuestSocialNetworksResponse' => '\\ArrayType\\ArrayOfGuestSocialNetworksResponse',
            'GetGuestSocialNetworksResponse' => '\\StructType\\GetGuestSocialNetworksResponse',
            'GetItemCountryRegionRequest' => '\\StructType\\GetItemCountryRegionRequest',
            'GetItemsRequest' => '\\StructType\\GetItemsRequest',
            'ItemResponse' => '\\StructType\\ItemResponse',
            'ArrayOfItemMemberResponse' => '\\ArrayType\\ArrayOfItemMemberResponse',
            'ItemMemberResponse' => '\\StructType\\ItemMemberResponse',
            'ArrayOfKitMemberResponse' => '\\ArrayType\\ArrayOfKitMemberResponse',
            'KitMemberResponse' => '\\StructType\\KitMemberResponse',
            'ArrayOfKitMemberItemResponse' => '\\ArrayType\\ArrayOfKitMemberItemResponse',
            'KitMemberItemResponse' => '\\StructType\\KitMemberItemResponse',
            'ArrayOfItemResponse' => '\\ArrayType\\ArrayOfItemResponse',
            'GetItemsResponse' => '\\StructType\\GetItemsResponse',
            'GetLoginSessionRequest' => '\\StructType\\GetLoginSessionRequest',
            'GetLoginSessionResponse' => '\\StructType\\GetLoginSessionResponse',
            'GetOrdersRequest' => '\\StructType\\GetOrdersRequest',
            'OrderResponse' => '\\StructType\\OrderResponse',
            'ArrayOfPaymentResponse' => '\\ArrayType\\ArrayOfPaymentResponse',
            'PaymentResponse' => '\\StructType\\PaymentResponse',
            'ArrayOfExpectedPaymentResponse' => '\\ArrayType\\ArrayOfExpectedPaymentResponse',
            'ExpectedPaymentResponse' => '\\StructType\\ExpectedPaymentResponse',
            'ArrayOfOrderResponse' => '\\ArrayType\\ArrayOfOrderResponse',
            'GetOrdersResponse' => '\\StructType\\GetOrdersResponse',
            'GetOrderTotalsRequest' => '\\StructType\\GetOrderTotalsRequest',
            'OrderTotalByCurrency' => '\\StructType\\OrderTotalByCurrency',
            'ArrayOfOrderTotalByCurrency' => '\\ArrayType\\ArrayOfOrderTotalByCurrency',
            'GetOrderTotalsResponse' => '\\StructType\\GetOrderTotalsResponse',
            'GetPartiesRequest' => '\\StructType\\GetPartiesRequest',
            'PartyResponse' => '\\StructType\\PartyResponse',
            'ArrayOfPartyResponse' => '\\ArrayType\\ArrayOfPartyResponse',
            'GetPartiesResponse' => '\\StructType\\GetPartiesResponse',
            'GetPartyGuestsRequest' => '\\StructType\\GetPartyGuestsRequest',
            'GetPartyGuestsResponse' => '\\StructType\\GetPartyGuestsResponse',
            'GetPaymentsRequest' => '\\StructType\\GetPaymentsRequest',
            'GetPaymentsResponse' => '\\StructType\\GetPaymentsResponse',
            'GetPointAccountRequest' => '\\StructType\\GetPointAccountRequest',
            'GetPointAccountResponse' => '\\StructType\\GetPointAccountResponse',
            'GetQualificationOverridesRequest' => '\\StructType\\GetQualificationOverridesRequest',
            'GetQualificationOverrideResponse' => '\\StructType\\GetQualificationOverrideResponse',
            'ArrayOfGetQualificationOverrideResponse' => '\\ArrayType\\ArrayOfGetQualificationOverrideResponse',
            'GetQualitificationOverridesResponse' => '\\StructType\\GetQualitificationOverridesResponse',
            'GetRandomMessageRequest' => '\\StructType\\GetRandomMessageRequest',
            'GetRandomMessageResponse' => '\\StructType\\GetRandomMessageResponse',
            'GetRankQualificationsRequest' => '\\StructType\\GetRankQualificationsRequest',
            'QualificationResponse' => '\\StructType\\QualificationResponse',
            'SupportingTable' => '\\StructType\\SupportingTable',
            'ArrayOfQualificationResponse' => '\\ArrayType\\ArrayOfQualificationResponse',
            'ArrayOfArrayOfQualificationResponse' => '\\ArrayType\\ArrayOfArrayOfQualificationResponse',
            'GetRankQualificationsResponse' => '\\StructType\\GetRankQualificationsResponse',
            'GetRealTimeCommissionDetailRequest' => '\\StructType\\GetRealTimeCommissionDetailRequest',
            'CommissionDetailResponse' => '\\StructType\\CommissionDetailResponse',
            'ArrayOfCommissionDetailResponse' => '\\ArrayType\\ArrayOfCommissionDetailResponse',
            'GetRealTimeCommissionDetailResponse' => '\\StructType\\GetRealTimeCommissionDetailResponse',
            'GetRealTimeCommissionsRequest' => '\\StructType\\GetRealTimeCommissionsRequest',
            'CommissionResponse' => '\\StructType\\CommissionResponse',
            'ArrayOfCommissionBonusResponse' => '\\ArrayType\\ArrayOfCommissionBonusResponse',
            'CommissionBonusResponse' => '\\StructType\\CommissionBonusResponse',
            'ArrayOfCommissionResponse' => '\\ArrayType\\ArrayOfCommissionResponse',
            'GetRealTimeCommissionsResponse' => '\\StructType\\GetRealTimeCommissionsResponse',
            'GetReportRequest' => '\\StructType\\GetReportRequest',
            'ArrayOfReportParameterRequest' => '\\ArrayType\\ArrayOfReportParameterRequest',
            'ReportParameterRequest' => '\\StructType\\ReportParameterRequest',
            'GetReportResponse' => '\\StructType\\GetReportResponse',
            'GetCommissionReportRequest' => '\\StructType\\GetCommissionReportRequest',
            'GetCommissionReportResponse' => '\\StructType\\GetCommissionReportResponse',
            'GetSandboxRequest' => '\\StructType\\GetSandboxRequest',
            'ArrayOfSandbox' => '\\ArrayType\\ArrayOfSandbox',
            'GetSandboxResponse' => '\\StructType\\GetSandboxResponse',
            'GetSessionRequest' => '\\StructType\\GetSessionRequest',
            'GetSessionResponse' => '\\StructType\\GetSessionResponse',
            'GetShipMethodsRequest' => '\\StructType\\GetShipMethodsRequest',
            'GetShipMethodsResponse' => '\\StructType\\GetShipMethodsResponse',
            'GetShoppingCartRequest' => '\\StructType\\GetShoppingCartRequest',
            'GetShoppingCartResponse' => '\\StructType\\GetShoppingCartResponse',
            'GetSubscriptionRequest' => '\\StructType\\GetSubscriptionRequest',
            'GetSubscriptionResponse' => '\\StructType\\GetSubscriptionResponse',
            'GetUplineRequest' => '\\StructType\\GetUplineRequest',
            'GetUplineResponse' => '\\StructType\\GetUplineResponse',
            'GetUserPermissionsRequest' => '\\StructType\\GetUserPermissionsRequest',
            'GetUserPermissionsResponse' => '\\StructType\\GetUserPermissionsResponse',
        );
    }
}
