<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdvancedAutoOptionsRequest StructType
 * @subpackage Structs
 */
class AdvancedAutoOptionsRequest extends AbstractStructBase
{
    /**
     * The ProcessWhileDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $ProcessWhileDate;
    /**
     * The SkipUntilDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SkipUntilDate;
    /**
     * The DetailStartDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DetailStartDate;
    /**
     * The DetailEndDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DetailEndDate;
    /**
     * The DetailInterval
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $DetailInterval;
    /**
     * Constructor method for AdvancedAutoOptionsRequest
     * @uses AdvancedAutoOptionsRequest::setProcessWhileDate()
     * @uses AdvancedAutoOptionsRequest::setSkipUntilDate()
     * @uses AdvancedAutoOptionsRequest::setDetailStartDate()
     * @uses AdvancedAutoOptionsRequest::setDetailEndDate()
     * @uses AdvancedAutoOptionsRequest::setDetailInterval()
     * @param string $processWhileDate
     * @param string $skipUntilDate
     * @param string $detailStartDate
     * @param string $detailEndDate
     * @param int $detailInterval
     */
    public function __construct($processWhileDate = null, $skipUntilDate = null, $detailStartDate = null, $detailEndDate = null, $detailInterval = null)
    {
        $this
            ->setProcessWhileDate($processWhileDate)
            ->setSkipUntilDate($skipUntilDate)
            ->setDetailStartDate($detailStartDate)
            ->setDetailEndDate($detailEndDate)
            ->setDetailInterval($detailInterval);
    }
    /**
     * Get ProcessWhileDate value
     * @return string
     */
    public function getProcessWhileDate()
    {
        return $this->ProcessWhileDate;
    }
    /**
     * Set ProcessWhileDate value
     * @param string $processWhileDate
     * @return \StructType\AdvancedAutoOptionsRequest
     */
    public function setProcessWhileDate($processWhileDate = null)
    {
        // validation for constraint: string
        if (!is_null($processWhileDate) && !is_string($processWhileDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($processWhileDate)), __LINE__);
        }
        $this->ProcessWhileDate = $processWhileDate;
        return $this;
    }
    /**
     * Get SkipUntilDate value
     * @return string
     */
    public function getSkipUntilDate()
    {
        return $this->SkipUntilDate;
    }
    /**
     * Set SkipUntilDate value
     * @param string $skipUntilDate
     * @return \StructType\AdvancedAutoOptionsRequest
     */
    public function setSkipUntilDate($skipUntilDate = null)
    {
        // validation for constraint: string
        if (!is_null($skipUntilDate) && !is_string($skipUntilDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($skipUntilDate)), __LINE__);
        }
        $this->SkipUntilDate = $skipUntilDate;
        return $this;
    }
    /**
     * Get DetailStartDate value
     * @return string
     */
    public function getDetailStartDate()
    {
        return $this->DetailStartDate;
    }
    /**
     * Set DetailStartDate value
     * @param string $detailStartDate
     * @return \StructType\AdvancedAutoOptionsRequest
     */
    public function setDetailStartDate($detailStartDate = null)
    {
        // validation for constraint: string
        if (!is_null($detailStartDate) && !is_string($detailStartDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($detailStartDate)), __LINE__);
        }
        $this->DetailStartDate = $detailStartDate;
        return $this;
    }
    /**
     * Get DetailEndDate value
     * @return string
     */
    public function getDetailEndDate()
    {
        return $this->DetailEndDate;
    }
    /**
     * Set DetailEndDate value
     * @param string $detailEndDate
     * @return \StructType\AdvancedAutoOptionsRequest
     */
    public function setDetailEndDate($detailEndDate = null)
    {
        // validation for constraint: string
        if (!is_null($detailEndDate) && !is_string($detailEndDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($detailEndDate)), __LINE__);
        }
        $this->DetailEndDate = $detailEndDate;
        return $this;
    }
    /**
     * Get DetailInterval value
     * @return int
     */
    public function getDetailInterval()
    {
        return $this->DetailInterval;
    }
    /**
     * Set DetailInterval value
     * @param int $detailInterval
     * @return \StructType\AdvancedAutoOptionsRequest
     */
    public function setDetailInterval($detailInterval = null)
    {
        // validation for constraint: int
        if (!is_null($detailInterval) && !is_numeric($detailInterval)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($detailInterval)), __LINE__);
        }
        $this->DetailInterval = $detailInterval;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AdvancedAutoOptionsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
