<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ApiWhitelistResponse StructType
 * @subpackage Structs
 */
class ApiWhitelistResponse extends AbstractStructBase
{
    /**
     * The IpRangeID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $IpRangeID;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The MinIP
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MinIP;
    /**
     * The MaxIP
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MaxIP;
    /**
     * Constructor method for ApiWhitelistResponse
     * @uses ApiWhitelistResponse::setIpRangeID()
     * @uses ApiWhitelistResponse::setDescription()
     * @uses ApiWhitelistResponse::setMinIP()
     * @uses ApiWhitelistResponse::setMaxIP()
     * @param int $ipRangeID
     * @param string $description
     * @param string $minIP
     * @param string $maxIP
     */
    public function __construct($ipRangeID = null, $description = null, $minIP = null, $maxIP = null)
    {
        $this
            ->setIpRangeID($ipRangeID)
            ->setDescription($description)
            ->setMinIP($minIP)
            ->setMaxIP($maxIP);
    }
    /**
     * Get IpRangeID value
     * @return int
     */
    public function getIpRangeID()
    {
        return $this->IpRangeID;
    }
    /**
     * Set IpRangeID value
     * @param int $ipRangeID
     * @return \StructType\ApiWhitelistResponse
     */
    public function setIpRangeID($ipRangeID = null)
    {
        // validation for constraint: int
        if (!is_null($ipRangeID) && !is_numeric($ipRangeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ipRangeID)), __LINE__);
        }
        $this->IpRangeID = $ipRangeID;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\ApiWhitelistResponse
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get MinIP value
     * @return string|null
     */
    public function getMinIP()
    {
        return $this->MinIP;
    }
    /**
     * Set MinIP value
     * @param string $minIP
     * @return \StructType\ApiWhitelistResponse
     */
    public function setMinIP($minIP = null)
    {
        // validation for constraint: string
        if (!is_null($minIP) && !is_string($minIP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($minIP)), __LINE__);
        }
        $this->MinIP = $minIP;
        return $this;
    }
    /**
     * Get MaxIP value
     * @return string|null
     */
    public function getMaxIP()
    {
        return $this->MaxIP;
    }
    /**
     * Set MaxIP value
     * @param string $maxIP
     * @return \StructType\ApiWhitelistResponse
     */
    public function setMaxIP($maxIP = null)
    {
        // validation for constraint: string
        if (!is_null($maxIP) && !is_string($maxIP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($maxIP)), __LINE__);
        }
        $this->MaxIP = $maxIP;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ApiWhitelistResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
