<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateCustomerLeadResponse StructType
 * @subpackage Structs
 */
class CreateCustomerLeadResponse extends ApiResponse
{
    /**
     * The CustomerLeadID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $CustomerLeadID;
    /**
     * Constructor method for CreateCustomerLeadResponse
     * @uses CreateCustomerLeadResponse::setCustomerLeadID()
     * @param int $customerLeadID
     */
    public function __construct($customerLeadID = null)
    {
        $this
            ->setCustomerLeadID($customerLeadID);
    }
    /**
     * Get CustomerLeadID value
     * @return int
     */
    public function getCustomerLeadID()
    {
        return $this->CustomerLeadID;
    }
    /**
     * Set CustomerLeadID value
     * @param int $customerLeadID
     * @return \StructType\CreateCustomerLeadResponse
     */
    public function setCustomerLeadID($customerLeadID = null)
    {
        // validation for constraint: int
        if (!is_null($customerLeadID) && !is_numeric($customerLeadID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($customerLeadID)), __LINE__);
        }
        $this->CustomerLeadID = $customerLeadID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateCustomerLeadResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
