<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateEntityRequest StructType
 * Meta informations extracted from the WSDL
 * - type: tns:CreateEntityRequest
 * @subpackage Structs
 */
class CreateEntityRequest extends ApiRequest
{
    /**
     * The Entity
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Entity
     */
    public $Entity;
    /**
     * Constructor method for CreateEntityRequest
     * @uses CreateEntityRequest::setEntity()
     * @param \StructType\Entity $entity
     */
    public function __construct(\StructType\Entity $entity = null)
    {
        $this
            ->setEntity($entity);
    }
    /**
     * Get Entity value
     * @return \StructType\Entity|null
     */
    public function getEntity()
    {
        return $this->Entity;
    }
    /**
     * Set Entity value
     * @param \StructType\Entity $entity
     * @return \StructType\CreateEntityRequest
     */
    public function setEntity(\StructType\Entity $entity = null)
    {
        $this->Entity = $entity;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateEntityRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
