<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerSocialNetworkRequest StructType
 * @subpackage Structs
 */
class CustomerSocialNetworkRequest extends AbstractStructBase
{
    /**
     * The SocialNetworkID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $SocialNetworkID;
    /**
     * The Url
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Url;
    /**
     * Constructor method for CustomerSocialNetworkRequest
     * @uses CustomerSocialNetworkRequest::setSocialNetworkID()
     * @uses CustomerSocialNetworkRequest::setUrl()
     * @param int $socialNetworkID
     * @param string $url
     */
    public function __construct($socialNetworkID = null, $url = null)
    {
        $this
            ->setSocialNetworkID($socialNetworkID)
            ->setUrl($url);
    }
    /**
     * Get SocialNetworkID value
     * @return int
     */
    public function getSocialNetworkID()
    {
        return $this->SocialNetworkID;
    }
    /**
     * Set SocialNetworkID value
     * @param int $socialNetworkID
     * @return \StructType\CustomerSocialNetworkRequest
     */
    public function setSocialNetworkID($socialNetworkID = null)
    {
        // validation for constraint: int
        if (!is_null($socialNetworkID) && !is_numeric($socialNetworkID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($socialNetworkID)), __LINE__);
        }
        $this->SocialNetworkID = $socialNetworkID;
        return $this;
    }
    /**
     * Get Url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->Url;
    }
    /**
     * Set Url value
     * @param string $url
     * @return \StructType\CustomerSocialNetworkRequest
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($url)), __LINE__);
        }
        $this->Url = $url;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CustomerSocialNetworkRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
