<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DeleteCustomerContactRequest StructType
 * Meta informations extracted from the WSDL
 * - type: tns:DeleteCustomerContactRequest
 * @subpackage Structs
 */
class DeleteCustomerContactRequest extends ApiRequest
{
    /**
     * The CustomerID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $CustomerID;
    /**
     * The CustomerContactID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $CustomerContactID;
    /**
     * The CustomerKey
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CustomerKey;
    /**
     * Constructor method for DeleteCustomerContactRequest
     * @uses DeleteCustomerContactRequest::setCustomerID()
     * @uses DeleteCustomerContactRequest::setCustomerContactID()
     * @uses DeleteCustomerContactRequest::setCustomerKey()
     * @param int $customerID
     * @param int $customerContactID
     * @param string $customerKey
     */
    public function __construct($customerID = null, $customerContactID = null, $customerKey = null)
    {
        $this
            ->setCustomerID($customerID)
            ->setCustomerContactID($customerContactID)
            ->setCustomerKey($customerKey);
    }
    /**
     * Get CustomerID value
     * @return int
     */
    public function getCustomerID()
    {
        return $this->CustomerID;
    }
    /**
     * Set CustomerID value
     * @param int $customerID
     * @return \StructType\DeleteCustomerContactRequest
     */
    public function setCustomerID($customerID = null)
    {
        // validation for constraint: int
        if (!is_null($customerID) && !is_numeric($customerID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($customerID)), __LINE__);
        }
        $this->CustomerID = $customerID;
        return $this;
    }
    /**
     * Get CustomerContactID value
     * @return int
     */
    public function getCustomerContactID()
    {
        return $this->CustomerContactID;
    }
    /**
     * Set CustomerContactID value
     * @param int $customerContactID
     * @return \StructType\DeleteCustomerContactRequest
     */
    public function setCustomerContactID($customerContactID = null)
    {
        // validation for constraint: int
        if (!is_null($customerContactID) && !is_numeric($customerContactID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($customerContactID)), __LINE__);
        }
        $this->CustomerContactID = $customerContactID;
        return $this;
    }
    /**
     * Get CustomerKey value
     * @return string|null
     */
    public function getCustomerKey()
    {
        return $this->CustomerKey;
    }
    /**
     * Set CustomerKey value
     * @param string $customerKey
     * @return \StructType\DeleteCustomerContactRequest
     */
    public function setCustomerKey($customerKey = null)
    {
        // validation for constraint: string
        if (!is_null($customerKey) && !is_string($customerKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customerKey)), __LINE__);
        }
        $this->CustomerKey = $customerKey;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeleteCustomerContactRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
