<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCustomerBillingResponse StructType
 * @subpackage Structs
 */
class GetCustomerBillingResponse extends ApiResponse
{
    /**
     * The PrimaryCreditCard
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CreditCardAccountResponse
     */
    public $PrimaryCreditCard;
    /**
     * The SecondaryCreditCard
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CreditCardAccountResponse
     */
    public $SecondaryCreditCard;
    /**
     * The BankAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\BankAccountResponse
     */
    public $BankAccount;
    /**
     * The PrimaryWalletAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\WalletAccountResponse
     */
    public $PrimaryWalletAccount;
    /**
     * The SecondaryWallletAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\WalletAccountResponse
     */
    public $SecondaryWallletAccount;
    /**
     * Constructor method for GetCustomerBillingResponse
     * @uses GetCustomerBillingResponse::setPrimaryCreditCard()
     * @uses GetCustomerBillingResponse::setSecondaryCreditCard()
     * @uses GetCustomerBillingResponse::setBankAccount()
     * @uses GetCustomerBillingResponse::setPrimaryWalletAccount()
     * @uses GetCustomerBillingResponse::setSecondaryWallletAccount()
     * @param \StructType\CreditCardAccountResponse $primaryCreditCard
     * @param \StructType\CreditCardAccountResponse $secondaryCreditCard
     * @param \StructType\BankAccountResponse $bankAccount
     * @param \StructType\WalletAccountResponse $primaryWalletAccount
     * @param \StructType\WalletAccountResponse $secondaryWallletAccount
     */
    public function __construct(\StructType\CreditCardAccountResponse $primaryCreditCard = null, \StructType\CreditCardAccountResponse $secondaryCreditCard = null, \StructType\BankAccountResponse $bankAccount = null, \StructType\WalletAccountResponse $primaryWalletAccount = null, \StructType\WalletAccountResponse $secondaryWallletAccount = null)
    {
        $this
            ->setPrimaryCreditCard($primaryCreditCard)
            ->setSecondaryCreditCard($secondaryCreditCard)
            ->setBankAccount($bankAccount)
            ->setPrimaryWalletAccount($primaryWalletAccount)
            ->setSecondaryWallletAccount($secondaryWallletAccount);
    }
    /**
     * Get PrimaryCreditCard value
     * @return \StructType\CreditCardAccountResponse|null
     */
    public function getPrimaryCreditCard()
    {
        return $this->PrimaryCreditCard;
    }
    /**
     * Set PrimaryCreditCard value
     * @param \StructType\CreditCardAccountResponse $primaryCreditCard
     * @return \StructType\GetCustomerBillingResponse
     */
    public function setPrimaryCreditCard(\StructType\CreditCardAccountResponse $primaryCreditCard = null)
    {
        $this->PrimaryCreditCard = $primaryCreditCard;
        return $this;
    }
    /**
     * Get SecondaryCreditCard value
     * @return \StructType\CreditCardAccountResponse|null
     */
    public function getSecondaryCreditCard()
    {
        return $this->SecondaryCreditCard;
    }
    /**
     * Set SecondaryCreditCard value
     * @param \StructType\CreditCardAccountResponse $secondaryCreditCard
     * @return \StructType\GetCustomerBillingResponse
     */
    public function setSecondaryCreditCard(\StructType\CreditCardAccountResponse $secondaryCreditCard = null)
    {
        $this->SecondaryCreditCard = $secondaryCreditCard;
        return $this;
    }
    /**
     * Get BankAccount value
     * @return \StructType\BankAccountResponse|null
     */
    public function getBankAccount()
    {
        return $this->BankAccount;
    }
    /**
     * Set BankAccount value
     * @param \StructType\BankAccountResponse $bankAccount
     * @return \StructType\GetCustomerBillingResponse
     */
    public function setBankAccount(\StructType\BankAccountResponse $bankAccount = null)
    {
        $this->BankAccount = $bankAccount;
        return $this;
    }
    /**
     * Get PrimaryWalletAccount value
     * @return \StructType\WalletAccountResponse|null
     */
    public function getPrimaryWalletAccount()
    {
        return $this->PrimaryWalletAccount;
    }
    /**
     * Set PrimaryWalletAccount value
     * @param \StructType\WalletAccountResponse $primaryWalletAccount
     * @return \StructType\GetCustomerBillingResponse
     */
    public function setPrimaryWalletAccount(\StructType\WalletAccountResponse $primaryWalletAccount = null)
    {
        $this->PrimaryWalletAccount = $primaryWalletAccount;
        return $this;
    }
    /**
     * Get SecondaryWallletAccount value
     * @return \StructType\WalletAccountResponse|null
     */
    public function getSecondaryWallletAccount()
    {
        return $this->SecondaryWallletAccount;
    }
    /**
     * Set SecondaryWallletAccount value
     * @param \StructType\WalletAccountResponse $secondaryWallletAccount
     * @return \StructType\GetCustomerBillingResponse
     */
    public function setSecondaryWallletAccount(\StructType\WalletAccountResponse $secondaryWallletAccount = null)
    {
        $this->SecondaryWallletAccount = $secondaryWallletAccount;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetCustomerBillingResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
