<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetOrderInvoiceResponse StructType
 * @subpackage Structs
 */
class GetOrderInvoiceResponse extends ApiResponse
{
    /**
     * The InvoiceData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InvoiceData;
    /**
     * Constructor method for GetOrderInvoiceResponse
     * @uses GetOrderInvoiceResponse::setInvoiceData()
     * @param string $invoiceData
     */
    public function __construct($invoiceData = null)
    {
        $this
            ->setInvoiceData($invoiceData);
    }
    /**
     * Get InvoiceData value
     * @return string|null
     */
    public function getInvoiceData()
    {
        return $this->InvoiceData;
    }
    /**
     * Set InvoiceData value
     * @param string $invoiceData
     * @return \StructType\GetOrderInvoiceResponse
     */
    public function setInvoiceData($invoiceData = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceData) && !is_string($invoiceData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($invoiceData)), __LINE__);
        }
        $this->InvoiceData = $invoiceData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetOrderInvoiceResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
