<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSchemaRequest StructType
 * Meta informations extracted from the WSDL
 * - type: tns:GetSchemaRequest
 * @subpackage Structs
 */
class GetSchemaRequest extends ApiRequest
{
    /**
     * The SchemaName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SchemaName;
    /**
     * Constructor method for GetSchemaRequest
     * @uses GetSchemaRequest::setSchemaName()
     * @param string $schemaName
     */
    public function __construct($schemaName = null)
    {
        $this
            ->setSchemaName($schemaName);
    }
    /**
     * Get SchemaName value
     * @return string|null
     */
    public function getSchemaName()
    {
        return $this->SchemaName;
    }
    /**
     * Set SchemaName value
     * @param string $schemaName
     * @return \StructType\GetSchemaRequest
     */
    public function setSchemaName($schemaName = null)
    {
        // validation for constraint: string
        if (!is_null($schemaName) && !is_string($schemaName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($schemaName)), __LINE__);
        }
        $this->SchemaName = $schemaName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetSchemaRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
