<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RefundPriorCreditCardChargeRequest StructType
 * Meta informations extracted from the WSDL
 * - type: tns:RefundPriorCreditCardChargeRequest
 * @subpackage Structs
 */
class RefundPriorCreditCardChargeRequest extends BaseCreatePaymentCreditCardRequest
{
    /**
     * The ReturnPaymentID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ReturnPaymentID;
    /**
     * The OrderID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $OrderID;
    /**
     * The MaxAmount
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $MaxAmount;
    /**
     * The OrderKey
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $OrderKey;
    /**
     * Constructor method for RefundPriorCreditCardChargeRequest
     * @uses RefundPriorCreditCardChargeRequest::setReturnPaymentID()
     * @uses RefundPriorCreditCardChargeRequest::setOrderID()
     * @uses RefundPriorCreditCardChargeRequest::setMaxAmount()
     * @uses RefundPriorCreditCardChargeRequest::setOrderKey()
     * @param int $returnPaymentID
     * @param int $orderID
     * @param float $maxAmount
     * @param string $orderKey
     */
    public function __construct($returnPaymentID = null, $orderID = null, $maxAmount = null, $orderKey = null)
    {
        $this
            ->setReturnPaymentID($returnPaymentID)
            ->setOrderID($orderID)
            ->setMaxAmount($maxAmount)
            ->setOrderKey($orderKey);
    }
    /**
     * Get ReturnPaymentID value
     * @return int
     */
    public function getReturnPaymentID()
    {
        return $this->ReturnPaymentID;
    }
    /**
     * Set ReturnPaymentID value
     * @param int $returnPaymentID
     * @return \StructType\RefundPriorCreditCardChargeRequest
     */
    public function setReturnPaymentID($returnPaymentID = null)
    {
        // validation for constraint: int
        if (!is_null($returnPaymentID) && !is_numeric($returnPaymentID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($returnPaymentID)), __LINE__);
        }
        $this->ReturnPaymentID = $returnPaymentID;
        return $this;
    }
    /**
     * Get OrderID value
     * @return int
     */
    public function getOrderID()
    {
        return $this->OrderID;
    }
    /**
     * Set OrderID value
     * @param int $orderID
     * @return \StructType\RefundPriorCreditCardChargeRequest
     */
    public function setOrderID($orderID = null)
    {
        // validation for constraint: int
        if (!is_null($orderID) && !is_numeric($orderID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($orderID)), __LINE__);
        }
        $this->OrderID = $orderID;
        return $this;
    }
    /**
     * Get MaxAmount value
     * @return float
     */
    public function getMaxAmount()
    {
        return $this->MaxAmount;
    }
    /**
     * Set MaxAmount value
     * @param float $maxAmount
     * @return \StructType\RefundPriorCreditCardChargeRequest
     */
    public function setMaxAmount($maxAmount = null)
    {
        $this->MaxAmount = $maxAmount;
        return $this;
    }
    /**
     * Get OrderKey value
     * @return string|null
     */
    public function getOrderKey()
    {
        return $this->OrderKey;
    }
    /**
     * Set OrderKey value
     * @param string $orderKey
     * @return \StructType\RefundPriorCreditCardChargeRequest
     */
    public function setOrderKey($orderKey = null)
    {
        // validation for constraint: string
        if (!is_null($orderKey) && !is_string($orderKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($orderKey)), __LINE__);
        }
        $this->OrderKey = $orderKey;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RefundPriorCreditCardChargeRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
