<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetItemImageRequest StructType
 * Meta informations extracted from the WSDL
 * - type: tns:SetItemImageRequest
 * @subpackage Structs
 */
class SetItemImageRequest extends ApiRequest
{
    /**
     * The ItemCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ItemCode;
    /**
     * The TinyImageName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TinyImageName;
    /**
     * The TinyImageData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TinyImageData;
    /**
     * The SmallImageName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SmallImageName;
    /**
     * The SmallImageData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SmallImageData;
    /**
     * The LargeImageName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LargeImageName;
    /**
     * The LargeImageData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LargeImageData;
    /**
     * Constructor method for SetItemImageRequest
     * @uses SetItemImageRequest::setItemCode()
     * @uses SetItemImageRequest::setTinyImageName()
     * @uses SetItemImageRequest::setTinyImageData()
     * @uses SetItemImageRequest::setSmallImageName()
     * @uses SetItemImageRequest::setSmallImageData()
     * @uses SetItemImageRequest::setLargeImageName()
     * @uses SetItemImageRequest::setLargeImageData()
     * @param string $itemCode
     * @param string $tinyImageName
     * @param string $tinyImageData
     * @param string $smallImageName
     * @param string $smallImageData
     * @param string $largeImageName
     * @param string $largeImageData
     */
    public function __construct($itemCode = null, $tinyImageName = null, $tinyImageData = null, $smallImageName = null, $smallImageData = null, $largeImageName = null, $largeImageData = null)
    {
        $this
            ->setItemCode($itemCode)
            ->setTinyImageName($tinyImageName)
            ->setTinyImageData($tinyImageData)
            ->setSmallImageName($smallImageName)
            ->setSmallImageData($smallImageData)
            ->setLargeImageName($largeImageName)
            ->setLargeImageData($largeImageData);
    }
    /**
     * Get ItemCode value
     * @return string|null
     */
    public function getItemCode()
    {
        return $this->ItemCode;
    }
    /**
     * Set ItemCode value
     * @param string $itemCode
     * @return \StructType\SetItemImageRequest
     */
    public function setItemCode($itemCode = null)
    {
        // validation for constraint: string
        if (!is_null($itemCode) && !is_string($itemCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($itemCode)), __LINE__);
        }
        $this->ItemCode = $itemCode;
        return $this;
    }
    /**
     * Get TinyImageName value
     * @return string|null
     */
    public function getTinyImageName()
    {
        return $this->TinyImageName;
    }
    /**
     * Set TinyImageName value
     * @param string $tinyImageName
     * @return \StructType\SetItemImageRequest
     */
    public function setTinyImageName($tinyImageName = null)
    {
        // validation for constraint: string
        if (!is_null($tinyImageName) && !is_string($tinyImageName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tinyImageName)), __LINE__);
        }
        $this->TinyImageName = $tinyImageName;
        return $this;
    }
    /**
     * Get TinyImageData value
     * @return string|null
     */
    public function getTinyImageData()
    {
        return $this->TinyImageData;
    }
    /**
     * Set TinyImageData value
     * @param string $tinyImageData
     * @return \StructType\SetItemImageRequest
     */
    public function setTinyImageData($tinyImageData = null)
    {
        // validation for constraint: string
        if (!is_null($tinyImageData) && !is_string($tinyImageData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tinyImageData)), __LINE__);
        }
        $this->TinyImageData = $tinyImageData;
        return $this;
    }
    /**
     * Get SmallImageName value
     * @return string|null
     */
    public function getSmallImageName()
    {
        return $this->SmallImageName;
    }
    /**
     * Set SmallImageName value
     * @param string $smallImageName
     * @return \StructType\SetItemImageRequest
     */
    public function setSmallImageName($smallImageName = null)
    {
        // validation for constraint: string
        if (!is_null($smallImageName) && !is_string($smallImageName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($smallImageName)), __LINE__);
        }
        $this->SmallImageName = $smallImageName;
        return $this;
    }
    /**
     * Get SmallImageData value
     * @return string|null
     */
    public function getSmallImageData()
    {
        return $this->SmallImageData;
    }
    /**
     * Set SmallImageData value
     * @param string $smallImageData
     * @return \StructType\SetItemImageRequest
     */
    public function setSmallImageData($smallImageData = null)
    {
        // validation for constraint: string
        if (!is_null($smallImageData) && !is_string($smallImageData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($smallImageData)), __LINE__);
        }
        $this->SmallImageData = $smallImageData;
        return $this;
    }
    /**
     * Get LargeImageName value
     * @return string|null
     */
    public function getLargeImageName()
    {
        return $this->LargeImageName;
    }
    /**
     * Set LargeImageName value
     * @param string $largeImageName
     * @return \StructType\SetItemImageRequest
     */
    public function setLargeImageName($largeImageName = null)
    {
        // validation for constraint: string
        if (!is_null($largeImageName) && !is_string($largeImageName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($largeImageName)), __LINE__);
        }
        $this->LargeImageName = $largeImageName;
        return $this;
    }
    /**
     * Get LargeImageData value
     * @return string|null
     */
    public function getLargeImageData()
    {
        return $this->LargeImageData;
    }
    /**
     * Set LargeImageData value
     * @param string $largeImageData
     * @return \StructType\SetItemImageRequest
     */
    public function setLargeImageData($largeImageData = null)
    {
        // validation for constraint: string
        if (!is_null($largeImageData) && !is_string($largeImageData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($largeImageData)), __LINE__);
        }
        $this->LargeImageData = $largeImageData;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetItemImageRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
