<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SetItemPriceRequest StructType
 * Meta informations extracted from the WSDL
 * - type: tns:SetItemPriceRequest
 * @subpackage Structs
 */
class SetItemPriceRequest extends ApiRequest
{
    /**
     * The PriceType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $PriceType;
    /**
     * The Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Price;
    /**
     * The BusinessVolume
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $BusinessVolume;
    /**
     * The CommissionableVolume
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $CommissionableVolume;
    /**
     * The TaxablePrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $TaxablePrice;
    /**
     * The ShippingPrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ShippingPrice;
    /**
     * The Other1Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other1Price;
    /**
     * The Other2Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other2Price;
    /**
     * The Other3Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other3Price;
    /**
     * The Other4Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other4Price;
    /**
     * The Other5Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other5Price;
    /**
     * The Other6Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other6Price;
    /**
     * The Other7Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other7Price;
    /**
     * The Other8Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other8Price;
    /**
     * The Other9Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other9Price;
    /**
     * The Other10Price
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $Other10Price;
    /**
     * The ItemCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ItemCode;
    /**
     * The CurrencyCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CurrencyCode;
    /**
     * Constructor method for SetItemPriceRequest
     * @uses SetItemPriceRequest::setPriceType()
     * @uses SetItemPriceRequest::setPrice()
     * @uses SetItemPriceRequest::setBusinessVolume()
     * @uses SetItemPriceRequest::setCommissionableVolume()
     * @uses SetItemPriceRequest::setTaxablePrice()
     * @uses SetItemPriceRequest::setShippingPrice()
     * @uses SetItemPriceRequest::setOther1Price()
     * @uses SetItemPriceRequest::setOther2Price()
     * @uses SetItemPriceRequest::setOther3Price()
     * @uses SetItemPriceRequest::setOther4Price()
     * @uses SetItemPriceRequest::setOther5Price()
     * @uses SetItemPriceRequest::setOther6Price()
     * @uses SetItemPriceRequest::setOther7Price()
     * @uses SetItemPriceRequest::setOther8Price()
     * @uses SetItemPriceRequest::setOther9Price()
     * @uses SetItemPriceRequest::setOther10Price()
     * @uses SetItemPriceRequest::setItemCode()
     * @uses SetItemPriceRequest::setCurrencyCode()
     * @param int $priceType
     * @param float $price
     * @param float $businessVolume
     * @param float $commissionableVolume
     * @param float $taxablePrice
     * @param float $shippingPrice
     * @param float $other1Price
     * @param float $other2Price
     * @param float $other3Price
     * @param float $other4Price
     * @param float $other5Price
     * @param float $other6Price
     * @param float $other7Price
     * @param float $other8Price
     * @param float $other9Price
     * @param float $other10Price
     * @param string $itemCode
     * @param string $currencyCode
     */
    public function __construct($priceType = null, $price = null, $businessVolume = null, $commissionableVolume = null, $taxablePrice = null, $shippingPrice = null, $other1Price = null, $other2Price = null, $other3Price = null, $other4Price = null, $other5Price = null, $other6Price = null, $other7Price = null, $other8Price = null, $other9Price = null, $other10Price = null, $itemCode = null, $currencyCode = null)
    {
        $this
            ->setPriceType($priceType)
            ->setPrice($price)
            ->setBusinessVolume($businessVolume)
            ->setCommissionableVolume($commissionableVolume)
            ->setTaxablePrice($taxablePrice)
            ->setShippingPrice($shippingPrice)
            ->setOther1Price($other1Price)
            ->setOther2Price($other2Price)
            ->setOther3Price($other3Price)
            ->setOther4Price($other4Price)
            ->setOther5Price($other5Price)
            ->setOther6Price($other6Price)
            ->setOther7Price($other7Price)
            ->setOther8Price($other8Price)
            ->setOther9Price($other9Price)
            ->setOther10Price($other10Price)
            ->setItemCode($itemCode)
            ->setCurrencyCode($currencyCode);
    }
    /**
     * Get PriceType value
     * @return int
     */
    public function getPriceType()
    {
        return $this->PriceType;
    }
    /**
     * Set PriceType value
     * @param int $priceType
     * @return \StructType\SetItemPriceRequest
     */
    public function setPriceType($priceType = null)
    {
        // validation for constraint: int
        if (!is_null($priceType) && !is_numeric($priceType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($priceType)), __LINE__);
        }
        $this->PriceType = $priceType;
        return $this;
    }
    /**
     * Get Price value
     * @return float
     */
    public function getPrice()
    {
        return $this->Price;
    }
    /**
     * Set Price value
     * @param float $price
     * @return \StructType\SetItemPriceRequest
     */
    public function setPrice($price = null)
    {
        $this->Price = $price;
        return $this;
    }
    /**
     * Get BusinessVolume value
     * @return float
     */
    public function getBusinessVolume()
    {
        return $this->BusinessVolume;
    }
    /**
     * Set BusinessVolume value
     * @param float $businessVolume
     * @return \StructType\SetItemPriceRequest
     */
    public function setBusinessVolume($businessVolume = null)
    {
        $this->BusinessVolume = $businessVolume;
        return $this;
    }
    /**
     * Get CommissionableVolume value
     * @return float
     */
    public function getCommissionableVolume()
    {
        return $this->CommissionableVolume;
    }
    /**
     * Set CommissionableVolume value
     * @param float $commissionableVolume
     * @return \StructType\SetItemPriceRequest
     */
    public function setCommissionableVolume($commissionableVolume = null)
    {
        $this->CommissionableVolume = $commissionableVolume;
        return $this;
    }
    /**
     * Get TaxablePrice value
     * @return float
     */
    public function getTaxablePrice()
    {
        return $this->TaxablePrice;
    }
    /**
     * Set TaxablePrice value
     * @param float $taxablePrice
     * @return \StructType\SetItemPriceRequest
     */
    public function setTaxablePrice($taxablePrice = null)
    {
        $this->TaxablePrice = $taxablePrice;
        return $this;
    }
    /**
     * Get ShippingPrice value
     * @return float
     */
    public function getShippingPrice()
    {
        return $this->ShippingPrice;
    }
    /**
     * Set ShippingPrice value
     * @param float $shippingPrice
     * @return \StructType\SetItemPriceRequest
     */
    public function setShippingPrice($shippingPrice = null)
    {
        $this->ShippingPrice = $shippingPrice;
        return $this;
    }
    /**
     * Get Other1Price value
     * @return float
     */
    public function getOther1Price()
    {
        return $this->Other1Price;
    }
    /**
     * Set Other1Price value
     * @param float $other1Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther1Price($other1Price = null)
    {
        $this->Other1Price = $other1Price;
        return $this;
    }
    /**
     * Get Other2Price value
     * @return float
     */
    public function getOther2Price()
    {
        return $this->Other2Price;
    }
    /**
     * Set Other2Price value
     * @param float $other2Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther2Price($other2Price = null)
    {
        $this->Other2Price = $other2Price;
        return $this;
    }
    /**
     * Get Other3Price value
     * @return float
     */
    public function getOther3Price()
    {
        return $this->Other3Price;
    }
    /**
     * Set Other3Price value
     * @param float $other3Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther3Price($other3Price = null)
    {
        $this->Other3Price = $other3Price;
        return $this;
    }
    /**
     * Get Other4Price value
     * @return float
     */
    public function getOther4Price()
    {
        return $this->Other4Price;
    }
    /**
     * Set Other4Price value
     * @param float $other4Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther4Price($other4Price = null)
    {
        $this->Other4Price = $other4Price;
        return $this;
    }
    /**
     * Get Other5Price value
     * @return float
     */
    public function getOther5Price()
    {
        return $this->Other5Price;
    }
    /**
     * Set Other5Price value
     * @param float $other5Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther5Price($other5Price = null)
    {
        $this->Other5Price = $other5Price;
        return $this;
    }
    /**
     * Get Other6Price value
     * @return float
     */
    public function getOther6Price()
    {
        return $this->Other6Price;
    }
    /**
     * Set Other6Price value
     * @param float $other6Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther6Price($other6Price = null)
    {
        $this->Other6Price = $other6Price;
        return $this;
    }
    /**
     * Get Other7Price value
     * @return float
     */
    public function getOther7Price()
    {
        return $this->Other7Price;
    }
    /**
     * Set Other7Price value
     * @param float $other7Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther7Price($other7Price = null)
    {
        $this->Other7Price = $other7Price;
        return $this;
    }
    /**
     * Get Other8Price value
     * @return float
     */
    public function getOther8Price()
    {
        return $this->Other8Price;
    }
    /**
     * Set Other8Price value
     * @param float $other8Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther8Price($other8Price = null)
    {
        $this->Other8Price = $other8Price;
        return $this;
    }
    /**
     * Get Other9Price value
     * @return float
     */
    public function getOther9Price()
    {
        return $this->Other9Price;
    }
    /**
     * Set Other9Price value
     * @param float $other9Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther9Price($other9Price = null)
    {
        $this->Other9Price = $other9Price;
        return $this;
    }
    /**
     * Get Other10Price value
     * @return float
     */
    public function getOther10Price()
    {
        return $this->Other10Price;
    }
    /**
     * Set Other10Price value
     * @param float $other10Price
     * @return \StructType\SetItemPriceRequest
     */
    public function setOther10Price($other10Price = null)
    {
        $this->Other10Price = $other10Price;
        return $this;
    }
    /**
     * Get ItemCode value
     * @return string|null
     */
    public function getItemCode()
    {
        return $this->ItemCode;
    }
    /**
     * Set ItemCode value
     * @param string $itemCode
     * @return \StructType\SetItemPriceRequest
     */
    public function setItemCode($itemCode = null)
    {
        // validation for constraint: string
        if (!is_null($itemCode) && !is_string($itemCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($itemCode)), __LINE__);
        }
        $this->ItemCode = $itemCode;
        return $this;
    }
    /**
     * Get CurrencyCode value
     * @return string|null
     */
    public function getCurrencyCode()
    {
        return $this->CurrencyCode;
    }
    /**
     * Set CurrencyCode value
     * @param string $currencyCode
     * @return \StructType\SetItemPriceRequest
     */
    public function setCurrencyCode($currencyCode = null)
    {
        // validation for constraint: string
        if (!is_null($currencyCode) && !is_string($currencyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($currencyCode)), __LINE__);
        }
        $this->CurrencyCode = $currencyCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SetItemPriceRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
